function RegisterSpawnFunction() end
dofile_once("data/scripts/biomes/crypt.lua")
dofile_once("data/scripts/director_helpers.lua")

for i,enemy in ipairs(g_big_enemies) do
  if enemy.entity == "data/entities/animals/biome_spawners/crypt/player_evil_spawner.xml" then
	table.remove(g_big_enemies, i)
	break
  end
end

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local pw = GetParallelWorldPosition( x, y )
local flag = "ne_player_evil_crypt_spawned" .. tostring(pw)
if not GameHasFlagRun(flag) then
	GameAddFlagRun(flag)
	EntityLoad("data/entities/animals/player_evil_green_sleep.xml", x, y )
else
	spawn(g_big_enemies, x, y)
end

EntityKill(entity_id)