function RegisterSpawnFunction() end
dofile_once("data/scripts/biomes/excavationsite.lua")
dofile_once("data/scripts/director_helpers.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local pw = GetParallelWorldPosition( x, y )
local flag = "ne_twig_grower_spawned" .. tostring(pw)
if not GameHasFlagRun(flag) then
	GameAddFlagRun(flag)
	EntityLoad("data/entities/animals/twig_grower.xml", x, y )
else
	for i,enemy in ipairs(g_small_enemies) do
	  if enemy.entity == "data/entities/animals/biome_spawners/excavationsite/twig_grower_spawner.xml" then
		table.remove(g_small_enemies, i)
		break
	  end
	end
	spawn(g_small_enemies, x, y)
end

EntityKill(entity_id)