function RegisterSpawnFunction() end
dofile_once("data/scripts/biomes/vault.lua")
dofile_once("data/scripts/director_helpers.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local pw = GetParallelWorldPosition( x, y )
local flag = "ne_terminator_spawned" .. tostring(pw)
if not GameHasFlagRun(flag) then
	GameAddFlagRun(flag)
	my_entry =
	{
		total_prob = 0,
		{
			prob   		= 100,
			min_count	= 1,
			max_count	= 1,    
			entity 	= "data/entities/animals/terminator.xml"
		}
	}
	spawn(my_entry, x, y)
else
	for i,enemy in ipairs(g_big_enemies) do
	  if enemy.entity == "data/entities/animals/biome_spawners/vault/terminator_spawner.xml" then
		table.remove(g_big_enemies, i)
		break
	  end
	end
	spawn(g_big_enemies, x, y)
end

EntityKill(entity_id)