local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")

if ( controls_component ~= nil ) and ( controls_component > 0 ) then

	local input = {
		ComponentGetValue(controls_component, "mButtonDownRight"), --right
		ComponentGetValue(controls_component, "mButtonDownUp"), --up
		ComponentGetValue(controls_component, "mButtonDownLeft"), --left
		ComponentGetValue(controls_component, "mButtonDownDown"), --down
	}

	local mass = 1

	local phys_body = EntityGetFirstComponent(entity_id, "PhysicsBodyComponent")

	if ( phys_body ~= nil ) and ( phys_body > 0 ) then
		local px, py, angle, vel_x, vel_y, angular_vel = PhysicsComponentGetTransform( phys_body )
		if input[1] == "1" then PhysicsComponentSetTransform( phys_body, px, py, angle, vel_x + 0.3 * mass, vel_y, angular_vel ) end
		if input[2] == "1" then PhysicsComponentSetTransform( phys_body, px, py, angle, vel_x, vel_y - 0.3 * mass, angular_vel ) end
		if input[3] == "1" then PhysicsComponentSetTransform( phys_body, px, py, angle, vel_x - 0.3 * mass, vel_y, angular_vel ) end
		if input[4] == "1" then PhysicsComponentSetTransform( phys_body, px, py, angle, vel_x, vel_y + 0.3 * mass, angular_vel ) end
	end

end