dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
  
-- local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
-- local sprite_component = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
-- local hitbox_component = EntityGetFirstComponentIncludingDisabled(entity_id, "HitboxComponent")
-- local damage_model_component = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
-- local status_effect_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "StatusEffectDataComponent")

-- EntityRemoveComponent(entity_id, animal_ai_component)
-- EntitySetComponentIsEnabled( entity_id, hitbox_component, false )
-- EntitySetComponentIsEnabled( entity_id, sprite_component, false )
-- EntitySetComponentIsEnabled( entity_id, damage_model_component, false )
-- EntitySetComponentIsEnabled( entity_id, status_effect_data_component, false )
-- EntitySetComponentIsEnabled( entity_id, GetUpdatedComponentID(), false )

EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)

local hitbox_component = EntityGetFirstComponent(entity_id, "HitboxComponent")
if ( hitbox_component ~= nil ) and ( hitbox_component > 0 ) then
	ComponentSetValue2( hitbox_component, "aabb_min_y", -1200 )
	ComponentSetValue2( hitbox_component, "aabb_max_y", -1200 )
	ComponentSetValue2( hitbox_component, "aabb_min_x", 0 )
	ComponentSetValue2( hitbox_component, "aabb_max_x", 0 )
end

local velocity_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VelocityComponent")
if ( velocity_component ~= nil ) and ( velocity_component > 0 ) then
	ComponentSetValue2( velocity_component, "mVelocity", 0, 0 )
end

local character_data_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
if ( character_data_component ~= nil ) and ( character_data_component > 0 ) then
	ComponentSetValue2( character_data_component, "mVelocity", 0, 0 )
end

-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

local proj_id = shoot_projectile( entity_id, "data/entities/projectiles/blob_ceiling.xml", x, y + 5 , 0, 250, false )
EntityAddChild(entity_id, proj_id)

local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}

for i, lua_comp in ipairs(lua_comps) do
	if ComponentGetValue2(lua_comp, "script_source_file") == "data/scripts/animals/blob_ceiling.lua" then
		EntityRemoveComponent( entity_id, lua_comp )
	end
end

local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
if ( variable_component ~= nil ) and ( variable_component > 0 ) then
	ComponentSetValue2( variable_component, "value_int", 1 )
end