function collision_trigger(colliding_entity)
	dofile_once("data/scripts/lib/utilities.lua")
	dofile_once( "data/scripts/invisibility_check.lua" )

	local entity_id = GetUpdatedEntityID()
	local x,y,rot = EntityGetTransform( entity_id )
	
	local entities = EntityGetInRadiusWithTag( x, y, 400, "fungitrap_02" )

	if ( #entities < 2 ) then
	
		if ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation( entity_id, colliding_entity ) < 40 ) and ( is_invisible(colliding_entity) == false ) then

			SetRandomSeed(GameGetFrameNum(), x + y + entity_id)

			function get_random_direction()
				return math.random() * 2 * math.pi
			end

			local ray_length = 300

			local angle = get_random_direction()
			local ray_x = x + ray_length * math.cos(angle)
			local ray_y = y + ray_length * math.sin(angle)

			local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, ray_x, ray_y)

			if did_hit then
				EntityLoad("data/entities/buildings/blood_fountain.xml", hit_x, hit_y)
			end
		end
	
	end
end