dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x  = EntityGetTransform(entity_id)

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
	local animal_ai_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AnimalAIComponent")
	if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
		ComponentSetValue2( animal_ai_component, "mGreatestPrey", players[1] )
		ComponentSetValue2( animal_ai_component, "mHasFoundPrey", true )
	end
end

-- SetRandomSeed(x + GameGetFrameNum(), y)
-- ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 10 + Random(140))
