dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()

EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

local character_platforming_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterPlatformingComponent")
if ( character_platforming_component ~= nil ) and ( character_platforming_component > 0 ) then
	ComponentSetValue2( character_platforming_component, "pixel_gravity", -600 )
	ComponentSetValue2( character_platforming_component, "jump_velocity_y", 0 )
	ComponentSetValue2( character_platforming_component, "run_velocity", 0 )
	ComponentSetValue2( character_platforming_component, "velocity_min_x", 0 )
	ComponentSetValue2( character_platforming_component, "velocity_max_x", 0 )
	ComponentSetValue2( character_platforming_component, "velocity_min_y", 0 )
	ComponentSetValue2( character_platforming_component, "velocity_max_y", 0 )
end