dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 350 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 350 then
			players = {polymorphed_player}
		end
	end
end

if ( BiomeMapGetName() ~= "$biome_holymountain" and #players > 0 )then
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", true)
else
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", false)
end