dofile_once( "data/scripts/lib/utilities.lua" )

spells = {
"gold_mimic_pain1",
"gold_mimic_pain2",
"gold_mimic_pain3"
}

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local random_index = Random(1, #spells)
local spell = spells[random_index]
local spell_path = "data/entities/projectiles/" .. spell .. ".xml"

local animal_ai_component = EntityGetFirstComponent(entity_id, "AnimalAIComponent")
if ( animal_ai_component ~= nil ) and ( animal_ai_component > 0 ) then
	ComponentSetValue2(animal_ai_component, "attack_ranged_entity_file", spell_path )
end