dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
  
	local player_x, player_y = EntityGetTransform(target)
		
	EntityLoad( "data/entities/projectiles/ear_boss_hand.xml", player_x , y + 20 )
  
end