dofile_once("data/scripts/lib/utilities.lua")

local range = 250

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then

		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		
		local lua_store_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
		
		for i, comp in ipairs(lua_store_comps) do

		
			if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/electrobot_tentacles.lua" then
				
				EntityRemoveComponent(entity_id, comp)
				
			end
			
		end
		
		for i, child in ipairs(EntityGetAllChildren(entity_id)  or {}) do
			if child > 0 then
				EntityKill(child)
			end
		end
		
		local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "initialised")
		ComponentSetValue2(var_comp, "value_bool", false)
		
	else
		local is_there = false
		
		local lua_store_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
		
		for i, comp in ipairs(lua_store_comps) do

		
			if ComponentGetValue2(comp, "script_source_file") == "data/scripts/animals/electrobot_tentacles.lua" then
				
				is_there = true
				
			end
			
		end
		if is_there == false then
			EntityAddComponent2(entity_id, "LuaComponent", {
				script_source_file="data/scripts/animals/electrobot_tentacles.lua",
				execute_every_n_frame=1,
				execute_on_added=true
			})
		end

		-- EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

	end
end