dofile_once("data/scripts/lib/utilities.lua")

local range = 400

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end
local target = players[1]

if ( target == nil ) or ( target == 0 ) then 
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", false)
else
	local tentacles = {}
	for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
		if EntityGetName(child) == "tentacle" then
			table.insert(tentacles, child)
		end
	end
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist < range then
		-- very near
		EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		if #tentacles <= 0 then
		
		    local ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)

		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)

		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/animals/lukki/lukki_dark_huge/limb_huge.xml", x, y)
			EntitySetTransform( ent, x, y )
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -30, 30, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine_short.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 30, 15, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 23, 23, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine_short.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -23, 16, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine_long.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 0, 2, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine_short.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", -12, 16, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/lukki_dark_huge/verlet_vine.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 12, 20, scale_x, scale_y, rot)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
			ent = EntityCreateNew()
			itc = EntityAddComponent2(ent, "InheritTransformComponent", {})
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(itc, "Transform")
			ComponentSetValue2(itc, "Transform", 0, -28, scale_x, scale_y, rot)
			EntityAddComponent2(ent, "CellEaterComponent", {
				ignored_material=CellFactory_GetType( "material_darkness" ),
				radius=45,
				eat_probability=100
			})
			EntitySetTransform(ent, x, y)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
			ent = EntityCreateNew()
			itc = EntityAddComponent2(ent, "InheritTransformComponent", {})
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(itc, "Transform")
			ComponentSetValue2(itc, "Transform", 27, 25, scale_x, scale_y, rot)
			EntityAddComponent2(ent, "CellEaterComponent", {
				ignored_material=CellFactory_GetType( "material_darkness" ),
				radius=35,
				eat_probability=100
			})
			EntitySetTransform(ent, x, y)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
			ent = EntityCreateNew()
			itc = EntityAddComponent2(ent, "InheritTransformComponent", {})
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(itc, "Transform")
			ComponentSetValue2(itc, "Transform", -27, 25, scale_x, scale_y, rot)
			EntityAddComponent2(ent, "CellEaterComponent", {
				ignored_material=CellFactory_GetType( "material_darkness" ),
				radius=35,
				eat_probability=100
			})
			EntitySetTransform(ent, x, y)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
		end
	else
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		if #tentacles > 0 then
			for _, tentacle in ipairs(tentacles or {} ) do
				EntityKill(tentacle)
			end
		end
	end
end
