dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

	local game_effect_component = EntityGetFirstComponentIncludingDisabled(child_id, "GameEffectComponent")
	
	if game_effect_component  and EntityGetName(child_id) ~= "important" then
	
		EntityKill(child_id)
		
	end

end