dofile_once("data/scripts/lib/utilities.lua")

local range = 400

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then
	
		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do
			if EntityGetName(child) == "tentacle" then
				EntityKill(child)
			end
		end
		
	else
	
		tentacles = 0

		for i, child in ipairs(EntityGetAllChildren(entity_id) or {}) do

		  if EntityGetName(child) == "tentacle" then
			tentacles = tentacles + 1
		  end
		
		end
		
		if tentacles == 0 then
			
		    local ent = EntityLoad("data/entities/verlet_chains/slime_tentacle/jellyfish/slime_tentacle_thin_01.xml", x, y)
			EntitySetTransform( ent, x, y )
			local inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			local tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, -3, scale_x, scale_y, rot)
			ComponentSetValue2(inherit_comp, "parent_sprite_id", 0)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/slime_tentacle/jellyfish/slime_tentacle_thin_01.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, -6, scale_x, scale_y, rot)
			ComponentSetValue2(inherit_comp, "parent_sprite_id", 0)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/slime_tentacle/jellyfish/slime_tentacle_thin_01.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, 0, scale_x, scale_y, rot)
			ComponentSetValue2(inherit_comp, "parent_sprite_id", 0)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/slime_tentacle/jellyfish/slime_tentacle_thin_01.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, 6, scale_x, scale_y, rot)
			ComponentSetValue2(inherit_comp, "parent_sprite_id", 0)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		    ent = EntityLoad("data/entities/verlet_chains/slime_tentacle/jellyfish/slime_tentacle_thin_01.xml", x, y)
			EntitySetTransform( ent, x, y )
			inherit_comp = EntityGetFirstComponentIncludingDisabled(ent, "InheritTransformComponent")
			tx, ty, scale_x, scale_y, rot = ComponentGetValue2(inherit_comp, "Transform")
			ComponentSetValue2(inherit_comp, "Transform", 4, 3, scale_x, scale_y, rot)
			ComponentSetValue2(inherit_comp, "parent_sprite_id", 0)
			EntitySetName(ent, "tentacle")
			EntityAddChild(entity_id, ent)
			
		end

	end
	
end