local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local parent_id = EntityGetRootEntity( entity_id )
local px, py = EntityGetTransform(parent_id)
EntitySetTransform( entity_id, px , py )

local components = EntityGetComponentIncludingDisabled(entity_id, "VariableStorageComponent")

local pos_comp, vel_comp, momentum_comp, init_comp

for _, comp_id in pairs(components) do
	local var_name = ComponentGetValue(comp_id, "name")
	if var_name == "targ_x" then
		ComponentSetValue2(comp_id, "value_float", x)
	elseif var_name == "targ_y" then
		ComponentSetValue2(comp_id, "value_float", y)
	end
end