dofile_once("data/scripts/lib/utilities.lua")

local range = 250

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]
--here just toggling scripts
if ( target ~= nil ) and ( target > 0 ) then
	local tx, ty = EntityGetTransform(target)
	local dist = get_distance(tx, ty, x, y)

	if dist > range then

		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		
		for i, child in ipairs(EntityGetAllChildren(entity_id)  or {}) do
			if child > 0 and EntityGetName(child) ~= "important" then
				EntityKill(child)
			end
		end
		
		local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent", "lurker_data")
		ComponentSetValue2(var_comp, "value_bool", false)
		
	else

		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

	end
end