dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once("data/scripts/new_enemies_utils.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local player_evil_id = EntityGetWithName( "$player_evil" )

if ( player_evil_id == nil ) or ( player_evil_id == 0 ) then
	local var_store_comp = get_variable_storage_component( entity_id, "position_tracker_evil" )
	if ( var_store_comp ~= nil ) and ( var_store_comp > 0 ) then
		EntityRemoveComponent(entity_id, var_store_comp)
	end
	
	local lua_comp = get_component_with_values(entity_id, "LuaComponent", { script_source_file = "data/scripts/misc/position_tracker_evil.lua" })
	if ( var_store_comp ~= nil ) and ( var_store_comp > 0 ) then
		EntityRemoveComponent(entity_id, lua_comp)
	end

	local this_lua_component = GetUpdatedComponentID()
	EntityRemoveComponent(entity_id, this_lua_component)
	
	GlobalsSetValue("new_enemies_player_evil_active", "0")
end
