local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
  local player_x, player_y = EntityGetTransform(players[1])

  
  if(x > player_x + 250) and BiomeMapGetName() == "$biome_lake" and player_y > 2000 then     
      x = player_x + 250
  end
  if(x < player_x - 250) and BiomeMapGetName() == "$biome_lake" and player_y > 2000 then
      x = player_x - 250
  end
  if(y > player_y + 200) and BiomeMapGetName() == "$biome_lake" and player_y > 2000 then
      y = player_y + 200
  end
  if(y < player_y - 200) and BiomeMapGetName() == "$biome_lake" and player_y > 2000 then
      y = player_y - 200
  end
  EntitySetTransform(entity_id, x, y)
  
  local worm_ai_component = EntityGetFirstComponentIncludingDisabled( entity_id, "WormAIComponent")
  
  if worm_ai_component then
	ComponentSetValue2( worm_ai_component, "mTargetEntityId", players[1] )
  end
end