dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)

local variable_component = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
if ( variable_component ~= nil ) and ( variable_component > 0 ) then
	local value = ComponentGetValue2(variable_component, "value_int")
	if value == 2 then
		local lua_comps = EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}

		for i, lua_comp in ipairs(lua_comps) do
			if ComponentGetValue2(lua_comp, "script_collision_trigger_hit") == "data/scripts/animals/stalker_land_implant.lua" then
				ComponentSetValue2( lua_comp, "script_collision_trigger_hit", "data/scripts/animals/stalker_ceiling_implant.lua" )
			end
		end
	end
end