dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source )
	local entity_id = GetUpdatedEntityID()
	local root_id = EntityGetRootEntity( entity_id )
	local x,y = EntityGetTransform( root_id )
	
	-- if ( source ~= nil ) and ( source ~= NULL_ENTITY ) and ( source ~= entity_id ) and ( source ~= root_id ) then
		-- local hm = EntityGetTransform( source )
		
		-- if ( hm ~= nil ) then
		-- EntitySetComponentsWithTagEnabled(root_id, "enabled_in_hand", false)
		-- print("testy")
		-- EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, root_id, x, y )
		-- GamePrint("it's working")
		-- GamePrint(dmg)
		-- EntitySetComponentsWithTagEnabled(root_id, "enabled_in_hand", true)
		-- end
	-- end
	
	local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local max_hp = ComponentGetValue2( comp, "max_hp" )
		ComponentSetValue2( comp, "hp", max_hp )
	end
	local comp = EntityGetFirstComponent( root_id, "DamageModelComponent" )
	if ( comp ~= nil ) then
		local hp = ComponentGetValue2( comp, "hp" )
		if hp - dmg > 0 then
		
			ComponentSetValue2( comp, "hp", hp - dmg )
			
		elseif hp - dmg <= 0 then
			-- local players = EntityGetInRadiusWithTag(x + 114, y + 114, 250, "player_unit")
			
			function get_distance(dx, dy, dx2, dy2)
				return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
			end
			--local x,y = EntityGetTransform( entity_id )
			local players = {}
			local player = EntityGetWithName( "DEBUG_NAME:player" )
			if ( player ~= nil ) and ( player > 0 ) then
				local px, py = EntityGetTransform(player)
				local dist = get_distance(x + 114, y + 114, px, py)
				if dist <= 250 then
					players = {player}
				end
			else
				local polymorphed_player = EntityGetClosestWithTag(x + 114, y + 114, "polymorphed_player")
				if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
					local px, py = EntityGetTransform(polymorphed_player)
					local dist = get_distance(x + 114, y + 114, px, py)
					if dist <= 250 then
						players = {polymorphed_player}
					end
				end
			end
			
			for i, luacomp in ipairs(EntityGetComponentIncludingDisabled( root_id, "LuaComponent" ) or {}) do
				if ComponentGetValue2( luacomp, "script_damage_about_to_be_received") == "data/scripts/animals/windmill_hitbox_move_to_position_hit.lua" then
					EntityRemoveComponent( root_id, luacomp )
				end
			end
			EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "NORMAL", 0, 0, players[1], x, y )
			EntityKill(entity_id)
		end
	end
end