local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 512 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 512 then
			players = {polymorphed_player}
		end
	end
end


local animal_ai_component = EntityGetFirstComponent(entity_id, "AnimalAIComponent")

if BiomeMapGetName() ~= "$biome_holymountain" and #players > 0 then
	ComponentSetValue2(animal_ai_component, "attack_ranged_enabled", true )
else
	ComponentSetValue2(animal_ai_component, "attack_ranged_enabled", false )
end