local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

function set_eater_on_all_children(entity, toggle)
	EntitySetComponentsWithTagEnabled(entity, "enable_when_player_seen", toggle)
	for i, child_id in ipairs(EntityGetAllChildren(entity) or {}) do
		set_eater_on_all_children(child_id, toggle)
	end
end

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local p = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 1000 then
		p = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 1000 then
			p = {polymorphed_player}
		end
	end
end

if ( BiomeMapGetName() ~= "$biome_holymountain" and #p > 0 )then
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", true)
	set_eater_on_all_children(entity_id, true)
else
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", false)
	set_eater_on_all_children(entity_id, false)
end