dofile_once("data/scripts/empty_enemy_helper_start.lua")

if not HasFlagPersistent("ned_bloodskull") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/meat/bloodskull.xml"
})
end

if not HasFlagPersistent("ned_flesh_monster") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/flesh_monster.xml"
})
end

if not HasFlagPersistent("ned_menace") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/menace.xml"
})
end

if not HasFlagPersistent("ned_flesh_wall") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 6,
    max_count	= 10,    
    entity 	= "data/entities/animals/flesh_wall.xml"
})
end

if not HasFlagPersistent("ned_brain2") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/brain2.xml"
})
end

if not HasFlagPersistent("ned_hand2") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/hand2.xml"
})
end

if not HasFlagPersistent("ned_tentacle_monster2") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/meat/tentacle_monster2.xml"
})
end

if not HasFlagPersistent("ned_fleshclops2") then
table.insert(g_big_enemies,
{
    prob   		= 0.1 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/meat/fleshclops2.xml"
})
end

if not HasFlagPersistent("ned_cerebracle") then
	table.insert(g_big_enemies, {
	prob           = 0.008 * global_prob,
	min_count    = 1,
	max_count    = 1,  
	entity     = "data/entities/animals/cerebracle.xml"
	})
end

if not HasFlagPersistent("ned_bloodmage_lesser") then
table.insert(g_big_enemies,
{
    prob   		= 0.08 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/bloodmage_lesser.xml"
})
end

if not HasFlagPersistent("ned_bloodmage_greater") then
table.insert(g_big_enemies,
{
    prob   		= 0.05 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "mods/new_enemies/data/entities/animals/bloodmage_greater.xml"
})
end

if not HasFlagPersistent("ned_bloodmage_enlightened") then
table.insert(g_big_enemies,
{
    prob   		= 0.01 * global_prob,
    min_count	= 1,
    max_count	= 1,    
    entity 	= "data/entities/animals/bloodmage_enlightened.xml"
})
end

if not HasFlagPersistent("ned_flesh_abomination2") then
	table.insert(g_big_enemies, {
	prob           = 0.01 * global_prob,
	min_count    = 1,
	max_count    = 1,  
	entity     = "data/entities/animals/biome_spawners/meat/flesh_abomination_spawner.xml"
	})
end

if not HasFlagPersistent("ned_blood_teddy") then
	table.insert(g_big_enemies, {
	prob           = 0.001 * global_prob,
	min_count    = 1,
	max_count    = 1,  
	entity     = "data/entities/animals/blood_teddy.xml"
	})
end

function spawn_skulls(x, y)
	SetRandomSeed(GameGetFrameNum(), x + y)
	local randnum = Random(100)
	if ( randnum <= 10 ) and ( not HasFlagPersistent("ned_head2") ) then
		EntityLoad("data/entities/animals/cancer2.xml", x, y + 6)
	elseif ( randnum <= 20 ) and ( not HasFlagPersistent("ned_ground_flesh2") ) then
		EntityLoad("data/entities/animals/ground_flesh2.xml", x, y + 6)
	else
		spawn(g_skulls,x,y,0,0)
	end
end

RegisterSpawnFunction( 0xffb4a00a, "spawn_fish" )

function spawn_fish(x, y)
	SetRandomSeed(GameGetFrameNum(), x + y)
	local rand_val = Random(1,10)
	for i=1,rand_val do
		EntityLoad("data/entities/animals/water_worm2.xml", x, y)
	end
end

dofile_once("data/scripts/empty_enemy_helper_end.lua")