dofile_once("data/scripts/empty_enemy_helper_start.lua")
if not HasFlagPersistent("ned_train") then
	function spawn_laser_trap(x, y)
		SetRandomSeed( x, y )
		
		LoadPixelScene( "data/biome_impl/vault/hole.png", "", x, y, "", true )
		
		local roll = Random( 1, 4 )
		
		local train_entity = 0
		local tx, ty = 0, 0
		
		local reseter = EntityGetClosestWithTag(  x, y, "pitcheck_b" )
		if ( reseter ~= nil ) and ( reseter > 0 ) then
			train_entity = EntityGetParent( reseter )
			tx, ty = EntityGetTransform( train_entity )
		end
		
        -- Dimensions of the train entity
        local train_width = 864
        local train_height = 131

        -- Check if the new train's area intersects with the existing train's area
        local function areas_intersect(x1, y1, x2, y2, width, height)
            return not (x1 + width <= x2 or
                        x1 >= x2 + width or
                        y1 + height <= y2 or
                        y1 >= y2 + height)
        end
        
		local trains_overlap = false
        if train_entity > 0 then
            if areas_intersect(x, y, tx, ty, train_width, train_height) then
                trains_overlap = true
            end
        end
		local this_biome = BiomeMapGetName( x, y )
		if ( this_biome == BiomeMapGetName( x + 280, y ) ) and
		( this_biome == BiomeMapGetName( x - 280, y ) ) and
		( this_biome == BiomeMapGetName( x, y - 65 ) ) and
		( this_biome == BiomeMapGetName( x, y + 65 ) ) and
		( this_biome == BiomeMapGetName( x + 280, y + 65 ) ) and
		( this_biome == BiomeMapGetName( x + 280, y - 65 ) ) and
		( this_biome == BiomeMapGetName( x - 280, y + 65 ) ) and
		( this_biome == BiomeMapGetName( x - 280, y - 65 ) ) then
		else
			trains_overlap = true
		end
		if ( Random( 1, 6 ) == 1 ) or ( trains_overlap == true ) then
			EntityLoad("data/entities/props/physics/trap_laser_toggling.xml", x + 5, y + 5)
		elseif Randomf() < ((1/6) * global_prob) then
			if ( roll == 1 ) then
				EntityLoad("data/entities/animals/train.xml", x + 5, y + 5)
			elseif ( roll == 2 ) then
				EntityLoad("data/entities/animals/train_left.xml", x + 5, y + 5)
			elseif ( roll == 3 ) then
				EntityLoad("data/entities/animals/train_long.xml", x + 5, y + 5)
			elseif ( roll == 4 ) then
				EntityLoad("data/entities/animals/train_left_long.xml", x + 5, y + 5)
			end
		end
	end
end