function damage_received(damage, message,entity_thats_responsible, is_fatal)
	dofile_once("data/scripts/lib/utilities.lua")
	local entity_id = GetUpdatedEntityID()
	local var_comp = get_variable_storage_component( entity_id, "sequence" )
	
	if ComponentGetValue2(var_comp, "value_bool") == false then
		local x, y = EntityGetTransform( entity_id )
		
		EntityAddComponent2(entity_id, "LuaComponent", {
			script_source_file="data/scripts/buildings/coffin_mummy_sequence.lua",
			execute_every_n_frame=1
		} )
		ComponentSetValue2(var_comp, "value_bool", true)
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		
	end
	
end

function collision_trigger( colliding_entity_id )
	dofile_once( "data/scripts/invisibility_check.lua" )
	dofile_once("data/scripts/lib/utilities.lua")
	local entity_id = GetUpdatedEntityID()
	local var_comp = get_variable_storage_component( entity_id, "sequence" )
	
	if ( ComponentGetValue2(var_comp, "value_bool") == false ) and 
	(EntityHasTag(colliding_entity_id, "projectile_player") == true or
		(
			(EntityHasTag(colliding_entity_id, "player_unit") == true and 
			EntityGetName(colliding_entity_id) == "DEBUG_NAME:player") or 
			EntityHasTag(colliding_entity_id, "polymorphed_player") == true
		) and 
		( ( EntityHasTag(colliding_entity_id, "polymorphed_player") == true ) or
		(EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") ~= nil and 
		EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") > 0 ) and 
		EntityGetHerdRelation(entity_id, colliding_entity_id) < 40 ) and 
		is_invisible(colliding_entity_id) == false
	) then
	
		local x, y = EntityGetTransform( entity_id )
		EntityAddComponent2(entity_id, "LuaComponent", {
			script_source_file="data/scripts/buildings/coffin_mummy_sequence.lua",
			execute_every_n_frame=1
		} )
		ComponentSetValue2(var_comp, "value_bool", true)
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
end