dofile_once( "data/scripts/lib/coroutines.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local orbcount = 0

function init_boss()
	local entity = GetUpdatedEntityID()
	
	local init_comp = get_variable_storage_component(entity, "initialized")
	
	local orbcount = GameGetOrbCountThisRun()

	-- look for stored initialization data
	--if get_variable_storage_component(entity, "initialized") == nil then
	if init_comp and ComponentGetValue2(init_comp, "value_bool") == false then
		ComponentSetValue2(init_comp, "value_bool", true)
		
		-- Set boss HP based on orbs
		-- local boss_hp = 46.0 + orbcount * 15.0
		-- local boss_hp = 23.0 + ( 2.0 ^ (orbcount+1.5) ) + orbcount
		local boss_hp = 500 + ( ( 2.0 ^ (orbcount + 1.3) ) + (orbcount*15.5)) * 0.0004

		local comp = EntityGetFirstComponentIncludingDisabled( entity, "DamageModelComponent" )
		if( comp ~= nil ) then
			ComponentSetValue2( comp, "max_hp", boss_hp )
			ComponentSetValue2( comp, "hp", boss_hp )
		end
	end
end

init_boss()