dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x,y,angle,scale_x,scale_y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 400 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 400 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 then
	for i, child_id in ipairs(EntityGetAllChildren(players[1]) or {}) do
		local shield_components = EntityGetComponentIncludingDisabled(child_id, "EnergyShieldComponent") or {}
		for i, comp in ipairs(shield_components) do
			ComponentSetValue2(comp, "energy", 0)
		end
	end
end