dofile_once( "data/scripts/invisibility_check.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 512 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 512 then
			players = {polymorphed_player}
		end
	end
end

if ( players[1] ~= nil ) and ( players[1] > 0 ) then
	if is_invisible(players[1]) == true then
		local px, py = EntityGetTransform( players[1] )
		local target_entity = EntityLoad( "data/entities/misc/place_target_on_player.xml", px, py)
		EntityAddChild(entity_id, target_entity)
		local comp = EntityGetFirstComponentIncludingDisabled( target_entity, "AttachToEntityComponent" )
		if ( comp ~= nil ) and ( comp > 0 ) then
			ComponentSetValue2( comp, "target", players[1] )
		end
		local comp = EntityGetFirstComponentIncludingDisabled( entity_id, "HomingComponent" )
		if ( comp ~= nil ) and ( comp > 0 ) then
			ComponentSetValue2( comp, "target_tag", "player_target" )
			ComponentSetValue2( comp, "predefined_target", target_entity)
			
			-- local target_tag = ComponentGetValue2(comp, "target_tag")
			-- local target_entity = ComponentGetValue2(comp, "predefined_target")
			
			-- GamePrint(tostring(target_tag) .. " " .. tostring(target_entity) .. " " .. tostring(players[1]))
		end
	end
end