local enemy_data = {
	skeleton = { name = "Skeleton", image = "data/ui_gfx/animal_icons/skeleton.png" },
	eye_bat = { name = "Eye Bat", image = "data/ui_gfx/animal_icons/eye_bat.png" },
	axeman = { name = "Axe Man", image = "data/ui_gfx/animal_icons/axeman.png" },
	dripper = { name = "Dripper", image = "data/ui_gfx/animal_icons/dripper.png" },
	-- desulitor = { name = "Desulitor", image = "data/ui_gfx/animal_icons/desulitor.png" },
	longleg_big = { name = "Large Spidey", image = "data/ui_gfx/animal_icons/longleg_big.png" },
	stalker = { name = "Stalker", image = "data/ui_gfx/animal_icons/stalker.png" },
	-- stalker_ceiling = { name = "Ceiling Stalker", image = "data/ui_gfx/animal_icons/stalker_ceiling.png" },
	hybrid = { name = "Hybrid", image = "data/ui_gfx/animal_icons/hybrid.png" },
	goomonster = { name = "Oozer (Goo Monster)", image = "data/ui_gfx/animal_icons/goomonster.png" },
	invisiman = { name = "Invisiman", image = "data/ui_gfx/animal_icons/invisiman.png" },
	archer = { name = "Archer", image = "data/ui_gfx/animal_icons/archer.png" },
	monkey = { name = "Monkey", image = "data/ui_gfx/animal_icons/monkey.png" },
	stone_crab = { name = "Stone Crab", image = "data/ui_gfx/animal_icons/stone_crab.png" },
	mutant_blob = { name = "Mutant Blob", image = "data/ui_gfx/animal_icons/mutant_blob.png" },
	bloodskull = { name = "Blood Skull", image = "data/ui_gfx/animal_icons/bloodskull.png" },
	-- driller = { name = "Driller", image = "data/ui_gfx/animal_icons/driller.png" },
	skullmage = { name = "Skull Mage", image = "data/ui_gfx/animal_icons/skullmage.png" },
	snowman = { name = "Snowman", image = "data/ui_gfx/animal_icons/snowman.png" },
	summoner = { name = "Summoner", image = "data/ui_gfx/animal_icons/summoner.png" },
	earthskull = { name = "Earth Skull", image = "data/ui_gfx/animal_icons/earthskull.png" },
	chest_great_mimic = { name = "Great Chest Mimic", image = "data/ui_gfx/animal_icons/chest_great_boss.png" },
	sneeker = { name = "Sneaker", image = "data/ui_gfx/animal_icons/sneeker.png" },
	fallen_alchemist = { name = "Fallen Alchemist", image = "data/ui_gfx/animal_icons/fallen_alchemist.png" },
	ground_terror = { name = "Ground Terror", image = "data/ui_gfx/animal_icons/ground_terror.png" },
	-- worm_eel = { name = "Electric Worm", image = "data/ui_gfx/animal_icons/worm_eel.png" },
	ooion = { name = "Ooion", image = "data/ui_gfx/animal_icons/ooion.png" },
	menace = { name = "Menace", image = "data/ui_gfx/animal_icons/menace.png" },
	slimeshooter_golden = { name = "Midas Sleaze Bag", image = "data/ui_gfx/animal_icons/slimeshooter_golden.png" },
	gonha = { name = "Gonha", image = "data/ui_gfx/animal_icons/gonha.png" },
	miner_alcohol = { name = "Boozer", image = "data/ui_gfx/animal_icons/miner_alcohol.png" },
	crawler = { name = "Crawler", image = "data/ui_gfx/animal_icons/crawler.png" },
	fire_crawler = { name = "Lava Crawler", image = "data/ui_gfx/animal_icons/fire_crawler_sprite.png" },
	enigma = { name = "Enigma", image = "data/ui_gfx/animal_icons/enigma.png" },
	bouncer = { name = "Bounce Bot", image = "data/ui_gfx/animal_icons/bouncer.png" },
	frog_bot = { name = "Frog Bot", image = "data/ui_gfx/animal_icons/frog_bot.png" },
	eye_monster = { name = "Cyclops Bat", image = "data/ui_gfx/animal_icons/eye_monster.png" },
	jellyfish = { name = "Jellyfish", image = "data/ui_gfx/animal_icons/jellyfish.png" },
	slime_turret = { name = "Sleaze Pod", image = "data/ui_gfx/animal_icons/slime_turret.png" },
	quin = { name = "Quin", image = "data/ui_gfx/animal_icons/quin.png" },
	flesh_wall = { name = "Wall Of Flesh", image = "data/ui_gfx/animal_icons/flesh_eye.png" },
	-- stingray = { name = "Stingray", image = "data/ui_gfx/animal_icons/stingray.png" },
	miner_boss = { name = "TNT Boss", image = "data/ui_gfx/animal_icons/miner_boss.png" },
	flesh_monster = { name = "Flesh Monster", image = "data/ui_gfx/animal_icons/flesh_monster.png" },
	fungus_spore = { name = "Spore Fungus", image = "data/ui_gfx/animal_icons/fungus_spore.png" },
	-- lurker = { name = "Lurker", image = "data/ui_gfx/animal_icons/lurker2.png" },
	ghostling = { name = "Ghostling", image = "data/ui_gfx/animal_icons/ghostling_skull.png" },
	drone = { name = "Swarmer Drone", image = "data/ui_gfx/animal_icons/drone2.png" },
	nautilus = { name = "Nautilus", image = "data/ui_gfx/animal_icons/nautilus.png" },
	spider = { name = "Ancient Spider", image = "data/ui_gfx/animal_icons/spider.png" },
	shapeshifter = { name = "Shape Shifter", image = "data/ui_gfx/animal_icons/shapeshifter.png" },
	bluemancer = { name = "Bluemancer", image = "data/ui_gfx/animal_icons/bluemancer.png" },
	alchaos = { name = "Alchaos", image = "data/ui_gfx/animal_icons/alchaos.png" },
	polyshooter = { name = "Polymorphine Slime", image = "data/ui_gfx/animal_icons/polyshooter.png" },
	chaoticpolyshooter = { name = "Chaotic Polymorphine Slime", image = "data/ui_gfx/animal_icons/chaoticpolyshooter.png" },
	wizard_time = { name = "Time Mage", image = "data/ui_gfx/animal_icons/wizard_time.png" },
	wizard_earthquake = { name = "Earthquake Mage", image = "data/ui_gfx/animal_icons/wizard_earthquake.png" },
	shiva = { name = "Shiva", image = "data/ui_gfx/animal_icons/shiva.png" },
	icicle_ceiling = { name = "Ceiling Icicle", image = "data/ui_gfx/animal_icons/extras/icicle_ceiling.png" },
	icicle = { name = "Icicle Creature", image = "data/ui_gfx/animal_icons/extras/icicle.png" },
	scavenger_laser = { name = "Laser Scavenger Hiisi", image = "data/ui_gfx/animal_icons/scavenger_laser.png" },
	scavenger_plasma = { name = "Plasma Scavenger Hiisi", image = "data/ui_gfx/animal_icons/scavenger_plasma.png" },
	icemage2 = { name = "Ice Mage", image = "data/ui_gfx/animal_icons/icemage2.png" },
	icicle_king = { name = "Icicle Master", image = "data/ui_gfx/animal_icons/icicle_king.png" },
	giant_old = { name = "Ancient Giant", image = "data/ui_gfx/animal_icons/giant_old.png" },
	giant_energy = { name = "Energy Orb Giant", image = "data/ui_gfx/animal_icons/giant_energy.png" },
	giant_alt = { name = "Giant Summoner", image = "data/ui_gfx/animal_icons/giant_alt.png" },
	thou = { name = "Thou", image = "data/ui_gfx/animal_icons/thou.png" },
	head_statue_physics = { name = "Frozen Soul", image = "data/ui_gfx/animal_icons/head_statue_physics.png" },
	scavenger_trigger = { name = "Trigger Scavenger Hiisi", image = "data/ui_gfx/animal_icons/scavenger_trigger.png" },
	electricskull = { name = "Electric Skull", image = "data/ui_gfx/animal_icons/electricskull.png" },
	tank_boss = { name = "Tank Boss", image = "data/ui_gfx/animal_icons/tank_boss.png" },
	-- boss_rock_spirit = { name = "Rock Spirit Boss", image = "data/ui_gfx/animal_icons/boss_rock_spirit.png" },
	book = { name = "Bewitched Tome", image = "data/ui_gfx/animal_icons/book.png" },
	long_ghost = { name = "Long Ghost", image = "data/ui_gfx/animal_icons/long_ghost.png" },
	watermonster = { name = "Water Spirit", image = "data/ui_gfx/animal_icons/watermonster.png" },
	bloodmonster = { name = "Blood Demon", image = "data/ui_gfx/animal_icons/bloodmonster.png" },
	-- wyrm = { name = "Wyrm", image = "data/ui_gfx/animal_icons/wyrm.png" },
	acidmonster = { name = "Acid Lurker", image = "data/ui_gfx/animal_icons/acidmonster.png" },
	lukki_white = { name = "Darkness Lukki", image = "data/ui_gfx/animal_icons/lukki_white.png" },
	lukki_blue = { name = "Eerie Lukki", image = "data/ui_gfx/animal_icons/lukki_blue.png" },
	worm_fungal = { name = "Fungal Abomination", image = "data/ui_gfx/animal_icons/extras/worm_fungal.png" },
	gigashooter = { name = "Giga Shooter", image = "data/ui_gfx/animal_icons/gigashooter.png" },
	-- hairling = { name = "Hairling", image = "data/ui_gfx/animal_icons/hairling.png" },
	moal = { name = "Moal", image = "data/ui_gfx/animal_icons/moal.png" },
	gazer_necromancer = { name = "Necromancer Gazer", image = "data/ui_gfx/animal_icons/gazer_necromancer.png" },
	-- cobra = { name = "Cobra", image = "data/ui_gfx/animal_icons/cobra.png" },
	-- stone_physics = { name = "Acid Touch Stone", image = "data/ui_gfx/animal_icons/stone_physics.png" },
	lavashooter = { name = "Lava Tentacler", image = "data/ui_gfx/animal_icons/lavashooter.png" },
	spooky_ghost = { name = "Spooky Ghost", image = "data/ui_gfx/animal_icons/spooky_ghost.png" },
	lukki_red = { name = "Lava Lukki", image = "data/ui_gfx/animal_icons/lukki_red.png" },
	phan = { name = "Phan", image = "data/ui_gfx/animal_icons/phan.png" },
	darkghost = { name = "Dark Gazer", image = "data/ui_gfx/animal_icons/darkghost2.png" },
	imp = { name = "Imp", image = "data/ui_gfx/animal_icons/imp.png" },
	draghoul = { name = "Hell Moth", image = "data/ui_gfx/animal_icons/draghoul.png" },
	scavenger_civilian = { name = "Hiisi Civilian", image = "data/ui_gfx/animal_icons/scavenger_civilian.png" },
	scavenger_alcohol = { name = "Alcohol Scavenger Hiisi", image = "data/ui_gfx/animal_icons/scavenger_alcohol.png" },
	cyborg = { name = "Cyborg Hiisi", image = "data/ui_gfx/animal_icons/cyborg.png" },
	bot = { name = "Laser Mech", image = "data/ui_gfx/animal_icons/bot.png" },
	laserbot = { name = "Death Laser Tripod", image = "data/ui_gfx/animal_icons/laserbot.png" },
	scavenger_king = { name = "Hiisi King", image = "data/ui_gfx/animal_icons/scavenger_king.png" },
	scavenger_compressor = { name = "Compressor Hiisi", image = "data/ui_gfx/animal_icons/scavenger_compressor.png" },
	scavenger_oiler = { name = "Oil Grenade Hiisi", image = "data/ui_gfx/animal_icons/scavenger_oiler.png" },
	scavenger_turbo = { name = "Turbo Hiisi", image = "data/ui_gfx/animal_icons/scavenger_turbo.png" },
	scavenger_gas = { name = "Gas Grenade Hiisi", image = "data/ui_gfx/animal_icons/scavenger_gas.png" },
	-- ceilingflower = { name = "Ceiling Slush Flower", image = "data/ui_gfx/animal_icons/ceilingflower.png" },
	landflower = { name = "Slush Flower", image = "data/ui_gfx/animal_icons/landflower.png" },
	ceiling_bloom = { name = "Ceiling Bloom", image = "data/ui_gfx/animal_icons/extras/bloom_ceiling.png" },
	earthmage = { name = "Earth Mage", image = "data/ui_gfx/animal_icons/earthmage.png" },
	bigfly = { name = "Giant Wasp", image = "data/ui_gfx/animal_icons/bigfly.png" },
	eyeling = { name = "Eyeling", image = "data/ui_gfx/animal_icons/eyeling.png" },
	-- fireflower = { name = "Dragon's Breath Flower", image = "data/ui_gfx/animal_icons/fireflower.png" },
	vine_monster = { name = "Vine Monster", image = "data/ui_gfx/animal_icons/vine_monster.png" },
	ent = { name = "Ent", image = "data/ui_gfx/animal_icons/ent.png" },
	scavenger_robot = { name = "Rocketier", image = "data/ui_gfx/animal_icons/scavenger_robot.png" },
	lukki_ominous = { name = "Ominous Lukki", image = "data/ui_gfx/animal_icons/lukki_ominous.png" },
	khulu = { name = "Khulu", image = "data/ui_gfx/animal_icons/khulu.png" },
	scavenger_compressor_robot = { name = "Compressor Robot Hiisi", image = "data/ui_gfx/animal_icons/scavenger_compressor_robot.png" },
	scavenger_radiolava = { name = "Radiolava Hiisi", image = "data/ui_gfx/animal_icons/scavenger_radiolava.png" },
	scavenger_turbo_robot = { name = "Turbo Robot", image = "data/ui_gfx/animal_icons/scavenger_turbo_robot.png" },
	scavenger_gas_robot = { name = "Gas Grenader", image = "data/ui_gfx/animal_icons/scavenger_gas_robot.png" },
	corrupt_alchemist = { name = "Corrupt Alchemist", image = "data/ui_gfx/animal_icons/corrupt_alchemist.png" },
	firemage_big = { name = "Giant Stendari", image = "data/ui_gfx/animal_icons/firemage_big.png" },
	eldari_big = { name = "Giant Eldari", image = "data/ui_gfx/animal_icons/eldari_big.png" },
	icemage_big2 = { name = "Giant Ice Mage", image = "data/ui_gfx/animal_icons/icemage_big2.png" },
	scavenger_undercover = { name = "Suspicious Hiisi", image = "data/ui_gfx/animal_icons/scavenger_undercover.png" },
	robot = { name = "Bazooka Mech", image = "data/ui_gfx/animal_icons/robot.png" },
	scavenger_king_robot = { name = "Robot Hiisi King", image = "data/ui_gfx/animal_icons/scavenger_king_robot.png" },
	worm_robot = { name = "Mecha Worm", image = "data/ui_gfx/animal_icons/worm_robot.png" },
	ghuu = { name = "Ghuu", image = "data/ui_gfx/animal_icons/ghuu.png" },
	nova = { name = "Nova", image = "data/ui_gfx/animal_icons/nova.png" },
	igu = { name = "Igu", image = "data/ui_gfx/animal_icons/igu.png" },
	forgotten_alchemist = { name = "Forgotten Alchemist", image = "data/ui_gfx/animal_icons/forgotten_alchemist.png" },
	bloodmage_lesser = { name = "Lesser Blood Mage", image = "data/ui_gfx/animal_icons/bloodmage_lesser.png" },
	bloodmage_greater = { name = "Greater Blood Mage", image = "data/ui_gfx/animal_icons/bloodmage_greater.png" },
	sochaos = { name = "Sochaos", image = "data/ui_gfx/animal_icons/sochaos.png" },
	serpentor = { name = "Serpentor", image = "data/ui_gfx/animal_icons/serpentor.png" },
	nightmare = { name = "Nightmare", image = "data/ui_gfx/animal_icons/nightmare.png" },
	zombie_giant = { name = "Giant Zombie", image = "data/ui_gfx/animal_icons/zombie_giant.png" },
	creeper = { name = "Creeper", image = "data/ui_gfx/animal_icons/creeper.png" },
	wraith_speed = { name = "Speed Wraith", image = "data/ui_gfx/animal_icons/wraith_speed.png" },
	face_worm = { name = "Orro Worm", image = "data/ui_gfx/animal_icons/face_worm.png" },
	lightling = { name = "Lightling", image = "data/ui_gfx/animal_icons/lightling.png" },
	gazer_laser = { name = "Laser Gazer", image = "data/ui_gfx/animal_icons/gazer_laser.png" },
	bird = { name = "Phoenix", image = "data/ui_gfx/animal_icons/bird.png" },
	-- naga = { name = "Naga", image = "data/ui_gfx/animal_icons/naga.png" },
	-- lava_monster = { name = "Lava Guardian", image = "data/ui_gfx/animal_icons/lava_monster.png" },
	desert_mage = { name = "Eldirood", image = "data/ui_gfx/animal_icons/desert_mage.png" },
	skeleboss = { name = "Skeleboss", image = "data/ui_gfx/animal_icons/skeleboss.png" },
	harpies = { name = "Harpies", image = "data/ui_gfx/animal_icons/extras/harpies.png" },
	seamonster = { name = "Sea Monster", image = "data/ui_gfx/animal_icons/seamonster.png" },
	lake_statue = { name = "Lake Statue", image = "data/ui_gfx/animal_icons/lake_statue.png" },
	skymonster = { name = "Sky Monster", image = "data/ui_gfx/animal_icons/skymonster.png" },
	furies = { name = "Furies", image = "data/ui_gfx/animal_icons/fury3.png" },
	-- ghust = { name = "Ghust", image = "data/ui_gfx/animal_icons/ghust.png" },
	golem = { name = "Golem", image = "data/ui_gfx/animal_icons/golem.png" },
	hydra = { name = "Hydra", image = "data/ui_gfx/animal_icons/hydra3.png" },
	mwyah = { name = "Mwyah", image = "data/ui_gfx/animal_icons/mwyah_face.png" },
	wraith_boss = { name = "Wraith Boss", image = "data/ui_gfx/animal_icons/wraith_boss.png" },
	-- god = { name = "God", image = "data/ui_gfx/animal_icons/god.png" },
	desert_skull = { name = "Desert Skull Boss", image = "data/ui_gfx/animal_icons/desert_skull.png" },
	giant_squid = { name = "Squid", image = "data/ui_gfx/animal_icons/giant_squid.png" },
	sea_angler = { name = "Angler Eel", image = "data/ui_gfx/animal_icons/angler.png" },
	sea_sharks = { name = "Sharks", image = "data/ui_gfx/animal_icons/shark.png" },
	piranha = { name = "Giant Piranha", image = "data/ui_gfx/animal_icons/piranha.png" },
	whale = { name = "Whale Monster", image = "data/ui_gfx/animal_icons/whale.png" },
	-- necromancer_polymorph = { name = "Polymorph Stevari", image = "data/ui_gfx/animal_icons/necromancer_polymorph.png" },
	peasants = { name = "Peasants", image = "data/ui_gfx/animal_icons/extras/peasants.png" },
	huts = { name = "Huts", image = "data/ui_gfx/animal_icons/extras/hut.png" },
	ritualists = { name = "Ritualists", image = "data/ui_gfx/animal_icons/extras/ritualist_c.png" },
	camels = { name = "Camels", image = "data/ui_gfx/animal_icons/camel.png" },
	mammoths = { name = "Mammoths", image = "data/ui_gfx/animal_icons/mammoth.png" },
	wizard_trip = { name = "Trip Mage", image = "data/ui_gfx/animal_icons/wizard_trip.png" },
	knight = { name = "Knight", image = "data/ui_gfx/animal_icons/knight.png" },
	menhir = { name = "Hell Menhir", image = "data/ui_gfx/animal_icons/menhir.png" },
	player_ai = { name = "Nemesis", image = "data/ui_gfx/animal_icons/player_ai_hitbox.png" },
	player_decoy = { name = "Ancient Scholar", image = "data/ui_gfx/animal_icons/player_decoy_hitbox.png" },
	twig = { name = "Nook", image = "data/ui_gfx/animal_icons/twig.png" },
	lost_soul = { name = "Lost Soul", image = "data/ui_gfx/animal_icons/lost_soul.png" },
	lost_soul_big = { name = "Giant Lost Soul", image = "data/ui_gfx/animal_icons/lost_soul_big.png" },
	blood_teddy = { name = "Caddel", image = "data/ui_gfx/animal_icons/blood_teddy.png" },
	toxicmage2 = { name = "Sludge Mage", image = "data/ui_gfx/animal_icons/toxicmage2.png" },
	toxicmage_acid2 = { name = "Acid Mage", image = "data/ui_gfx/animal_icons/toxicmage_acid2.png" },
	potionmaster2 = { name = "Potion Master", image = "data/ui_gfx/animal_icons/potionmaster2.png" },
	phantom_trapper = { name = "Trapper Phantom", image = "data/ui_gfx/animal_icons/phantom_trapper.png" },
	void_mask2 = { name = "Void Skull", image = "data/ui_gfx/animal_icons/void_mask2.png" },
	wandmaster2 = { name = "Wand Master", image = "data/ui_gfx/animal_icons/wandmaster2.png" },
	valkyrie2 = { name = "Valkyrie", image = "data/ui_gfx/animal_icons/valkyrie2.png" },
	drone_face2 = { name = "Inferno Drone", image = "data/ui_gfx/animal_icons/drone_face2.png" },
	scavenger_electrocuter2 = { name = "Electrocuter Scavenger", image = "data/ui_gfx/animal_icons/scavenger_electrocuter2.png" },
	fungus_swamp2 = { name = "Rotting Fungus", image = "data/ui_gfx/animal_icons/fungus_swamp2.png" },
	lukki_swamp2 = { name = "Rotting Lukki", image = "data/ui_gfx/animal_icons/lukki_swamp2.png" },
	smoke_bot = { name = "Smoke Machine", image = "data/ui_gfx/animal_icons/smoke_bot.png" },
	mutant2 = { name = "Mutant", image = "data/ui_gfx/animal_icons/mutant2.png" },
	alien = { name = "Suuka", image = "data/ui_gfx/animal_icons/alien.png" },
	-- giantfirebug = { name = "Massive Firefly", image = "data/ui_gfx/animal_icons/giantfirebug.png" },
	-- blob_giant = { name = "Infestant Blob", image = "data/ui_gfx/animal_icons/blob_giant.png" },
	wraith_void2 = { name = "Void Wraith", image = "data/ui_gfx/animal_icons/wraith_void2.png" },
	singularitor = { name = "Singularitor", image = "data/ui_gfx/animal_icons/singularitor.png" },
	sawbot = { name = "Saw Bot", image = "data/ui_gfx/animal_icons/sawbot.png" },
	-- wanderer = { name = "Abu", image = "data/ui_gfx/animal_icons/wanderer.png" },
	commander = { name = "Commander", image = "data/ui_gfx/animal_icons/commander.png" },
	junkbot = { name = "Junk Bot", image = "data/ui_gfx/animal_icons/junkbot.png" },
	cargobot = { name = "Cargo Bot", image = "data/ui_gfx/animal_icons/cargobot.png" },
	electrobot = { name = "Electro Bot", image = "data/ui_gfx/animal_icons/electrobot.png" },
	train = { name = "Underground Train", image = "data/ui_gfx/animal_icons/train.png" },
	radiobot = { name = "Radioactive Orb", image = "data/ui_gfx/animal_icons/radiobot.png" },
	lempo = { name = "Lempo", image = "data/ui_gfx/animal_icons/lempo.png" },
	hazmat = { name = "Hazmat", image = "data/ui_gfx/animal_icons/hazmat.png" },
	drone_beam = { name = "Beam Drone", image = "data/ui_gfx/animal_icons/drone_beam.png" },
	wizard_random = { name = "Master Of Multitude", image = "data/ui_gfx/animal_icons/wizard_random.png" },
	slimeshooter_mega = { name = "Mother Slime", image = "data/ui_gfx/animal_icons/slimeshooter_mega.png" },
	tank_propane = { name = "Secret Tank", image = "data/ui_gfx/animal_icons/extras/tank_propane.png" },
	alligator = { name = "Large Alligator", image = "data/ui_gfx/animal_icons/alligator_temple.png" },
	alligator_small = { name = "Alligator", image = "data/ui_gfx/animal_icons/alligator_temple_small.png" },
	medusa = { name = "Medusa", image = "data/ui_gfx/animal_icons/medusa.png" },
	terminator = { name = "Terminator", image = "data/ui_gfx/animal_icons/terminator.png" },
	lukki_weird = { name = "Putrid Lukki", image = "data/ui_gfx/animal_icons/lukki_weird.png" },
	wizard_twin = { name = "Master Of Cloning", image = "data/ui_gfx/animal_icons/wizard_twin.png" },
	windmill = { name = "Hiisi Airship", image = "data/ui_gfx/animal_icons/windmill.png" },
	slime_ghoul = { name = "Sleaze Ghoul", image = "data/ui_gfx/animal_icons/slime_ghoul.png" },
	-- drake_snake = { name = "Draken", image = "data/ui_gfx/animal_icons/drake_snake.png" },
	mirror_physics = { name = "Vollux", image = "data/ui_gfx/animal_icons/mirror_physics.png" },
	eradicator = { name = "Eradicator Droid", image = "data/ui_gfx/animal_icons/eradicator.png" },
	wizard_madness = { name = "Master Of Madness", image = "data/ui_gfx/animal_icons/wizard_madness.png" },
	sporeling_tiny = { name = "Tiny Sporeling", image = "data/ui_gfx/animal_icons/sporeling_tiny.png" },
	sporeling = { name = "Medium Sporeling", image = "data/ui_gfx/animal_icons/sporeling.png" },
	sporeling_large = { name = "Large Sporeling", image = "data/ui_gfx/animal_icons/sporeling_large.png" },
	phantom_boss = { name = "Restless Phantom", image = "data/ui_gfx/animal_icons/phantom_boss.png" },
	scavenger_poison_immunity = { name = "Poison Medic Hiisi", image = "data/ui_gfx/animal_icons/scavenger_poison_immunity.png" },
	tank_fire2 = { name = "Flame Tank", image = "data/ui_gfx/animal_icons/tank_fire2.png" },
	irtokki = { name = "Irtokki", image = "data/ui_gfx/animal_icons/irtokki.png" },
	aquatitan = { name = "Aquatitan", image = "data/ui_gfx/animal_icons/aquatitan.png" },
	skull_abomination = { name = "Skull Abomination", image = "data/ui_gfx/animal_icons/skull_abomination.png" },
	drone_trail = { name = "Static Drone", image = "data/ui_gfx/animal_icons/drone_trail.png" },
	conduit = { name = "Conduit", image = "data/ui_gfx/animal_icons/conduit.png" },
	polyp_gas = { name = "Gasnacle", image = "data/ui_gfx/animal_icons/polyp_gas.png" },
	manus = { name = "Manus", image = "data/ui_gfx/animal_icons/manus.png" },
	hurpa = { name = "Hurpa", image = "data/ui_gfx/animal_icons/hurpa.png" },
	flutterpede = { name = "Flutterpede", image = "data/ui_gfx/animal_icons/flutterpede.png" },
	welder = { name = "Hiisi Welder", image = "data/ui_gfx/animal_icons/welder.png" },
	copter = { name = "Hiisi Copter", image = "data/ui_gfx/animal_icons/copter.png" },
	necromancer_omega = { name = "Omegamancer", image = "data/ui_gfx/animal_icons/necromancer_omega.png" },
	cryogen = { name = "Cryogen", image = "data/ui_gfx/animal_icons/cryogen.png" },
	mother_nature = { name = "Gaia", image = "data/ui_gfx/animal_icons/mother_nature.png" },
	dragon_ice = { name = "Dragutt Kiesah", image = "data/ui_gfx/animal_icons/dragon_ice.png" },
	hell_overseer = { name = "Infernal Colossus", image = "data/ui_gfx/animal_icons/hell_overseer.png" },
	tardigrade = { name = "Tardigrade", image = "data/ui_gfx/animal_icons/tardigrade.png" },
	cerebracle = { name = "Cerebracle", image = "data/ui_gfx/animal_icons/cerebracle.png" },
	llama = { name = "Llama", image = "data/ui_gfx/animal_icons/llama.png" },
	-- ants = { name = "Ants", image = "data/ui_gfx/animal_icons/extras/ants.png" },
	-- water_bugs = { name = "Water Bugs", image = "data/ui_gfx/animal_icons/extras/water_bug.png" },
	-- earth_worms = { name = "Earth Worms", image = "data/ui_gfx/animal_icons/extras/earth_worms.png" },
	-- spiders = { name = "Spiders", image = "data/ui_gfx/animal_icons/extras/spiders.png" },
	skullspider = { name = "Skull Spider", image = "data/ui_gfx/animal_icons/skullspider.png" },
	beanpodupine = { name = "Podupine", image = "data/ui_gfx/animal_icons/beanpodupine.png" },
	scarab = { name = "Scarab Beetle", image = "data/ui_gfx/animal_icons/scarab.png" },
	stork = { name = "Avian Giant", image = "data/ui_gfx/animal_icons/stork.png" },
	devourer = { name = "Morsa", image = "data/ui_gfx/animal_icons/devourer.png" },
	sea_angler2 = { name = "Angler Fish", image = "data/ui_gfx/animal_icons/fish_angler2.png" },
	zap_eel2 = { name = "Electric Eel", image = "data/ui_gfx/animal_icons/zap_eel2.png" },
	minabomination = { name = "Failed Abomination", image = "data/ui_gfx/animal_icons/minabomination.png" },
	camel_robot = { name = "I160", image = "data/ui_gfx/animal_icons/camel_robot.png" },
	magiconstruct = { name = "The Sanctuary", image = "data/ui_gfx/animal_icons/magiconstruct.png" },
	elephant = { name = "Vulcan", image = "data/ui_gfx/animal_icons/elephant.png" },
	yikka = { name = "Yikka", image = "data/ui_gfx/animal_icons/yikka_ghost.png" },
	lukki_dark_huge = { name = "Sarlacc", image = "data/ui_gfx/animal_icons/lukki_dark_huge.png" },
	giant_boss = { name = "Rock Spirit Colossus", image = "data/ui_gfx/animal_icons/giant_boss.png" },
	god_warrior = { name = "God Warrior", image = "data/ui_gfx/animal_icons/god_warrior.png" },
	cthulhu = { name = "Abyssum", image = "data/ui_gfx/animal_icons/cthulhu.png" },
	wizard_tiny = { name = "Master Of Shrinking", image = "data/ui_gfx/animal_icons/wizard_tiny.png" },
	flopper_mother = { name = "Emesus", image = "data/ui_gfx/animal_icons/flopper_mother.png" },
	xopon = { name = "Xopon", image = "data/ui_gfx/animal_icons/xopon.png" },
	oruai = { name = "Oruai Sphere", image = "data/ui_gfx/animal_icons/oruai.png" },
	jungle_flower = { name = "Grappling Bloom", image = "data/ui_gfx/animal_icons/jungle_flower.png" },
	boids = { name = "Birds", image = "data/ui_gfx/animal_icons/boid.png" },
	sand_worm = { name = "Colossal Sand Worm", image = "data/ui_gfx/animal_icons/sand_worm.png" },
	kiwiki = { name = "Kiwiki", image = "data/ui_gfx/animal_icons/kiwiki.png" },
	shield_physics = { name = "Sentinel", image = "data/ui_gfx/animal_icons/shield_physics.png" },
	flopper_mother_giant = { name = "Giant Emesus", image = "data/ui_gfx/animal_icons/flopper_mother_giant.png" },
	crawler_bug = { name = "Fire Bug", image = "data/ui_gfx/animal_icons/crawler_bug.png" },
	platoon = { name = "Platoon", image = "data/ui_gfx/animal_icons/platoon.png" },
	scorpio = { name = "Scorpio", image = "data/ui_gfx/animal_icons/scorpio.png" },
	mountain = { name = "The Mountain", image = "data/ui_gfx/animal_icons/mountain.png" },
	peeper = { name = "Peeper", image = "data/ui_gfx/animal_icons/extras/peeper.png" },
	mantis = { name = "Mantis", image = "data/ui_gfx/animal_icons/mantis.png" },
	gold_face_physics = { name = "God's Finger", image = "data/ui_gfx/animal_icons/gold_face_physics.png" },
	chameleon = { name = "Chameleon", image = "data/ui_gfx/animal_icons/chameleon.png" },
	bloodmage_enlightened = { name = "Ascended Blood Mage", image = "data/ui_gfx/animal_icons/bloodmage_enlightened.png" },
	elephant_robot = { name = "Titan Tusk", image = "data/ui_gfx/animal_icons/elephant_robot.png" },
	fireworkman = { name = "Fireworker", image = "data/ui_gfx/animal_icons/fireworkman.png" },
	beehive = { name = "Beehive", image = "data/ui_gfx/animal_icons/beehive.png" },
	mountain_large = { name = "Geocolossus", image = "data/ui_gfx/animal_icons/mountain_large.png" },
	spider_crawler = { name = "Crawling Spider", image = "data/ui_gfx/animal_icons/spider_crawler.png" },
	larva_crawler = { name = "Silk Worm", image = "data/ui_gfx/animal_icons/larva_crawler.png" },
	plant_boss = { name = "Overgrowth", image = "data/ui_gfx/animal_icons/plant_boss.png" },
	drill_giant = { name = "Excavator Drill", image = "data/ui_gfx/animal_icons/drill_giant.png" },
	mule = { name = "Mule", image = "data/ui_gfx/animal_icons/mule.png" },
	ear_boss = { name = "Enchanted Corridor", image = "data/ui_gfx/animal_icons/extras/ear_boss.png" },
	cyclops_slime = { name = "Aberrant Abomination", image = "data/ui_gfx/animal_icons/extras/cyclops_slime.png" },
	boss_eel = { name = "Dutchman Eel", image = "data/ui_gfx/animal_icons/extras/boss_eel.png" },
	boss_fungus = { name = "Fungal Colossus", image = "data/ui_gfx/animal_icons/extras/boss_fungus.png" },
	corpse_lily = { name = "Corpse Lily", image = "data/ui_gfx/animal_icons/corpse_lily.png" },
	jungle_worm = { name = "Mutant Worm", image = "data/ui_gfx/animal_icons/jungle_worm.png" },
	hell_door = { name = "Chaos Door", image = "data/ui_gfx/animal_icons/hell_door.png" },
	mummy = { name = "Mummy", image = "data/ui_gfx/animal_icons/mummy.png" },
	worm_portal = { name = "Portal Worm", image = "data/ui_gfx/animal_icons/worm_portal.png" },
	mexxi = { name = "Mexxi", image = "data/ui_gfx/animal_icons/mexxi.png" },
	hellion = { name = "Hellion", image = "data/ui_gfx/animal_icons/extras/hellion.png" },
	mechahub = { name = "Desolate Core", image = "data/ui_gfx/animal_icons/mechahub.png" },
	manticore = { name = "Manticore", image = "data/ui_gfx/animal_icons/manticore.png" },
	player_evil = { name = "Fiend", image = "data/ui_gfx/animal_icons/player_evil.png" },
	puffer = { name = "Pufferfish", image = "data/ui_gfx/animal_icons/puffer.png" },
	yoyoer = { name = "Yoyoer", image = "data/ui_gfx/animal_icons/yoyoer.png" },
	lukki_saw = { name = "Saw Spider", image = "data/ui_gfx/animal_icons/lukki_saw.png" },
	jungle_deity = { name = "Jungle Deity", image = "data/ui_gfx/animal_icons/jungle_deity.png" },
	tentacle_monster2 = { name = "Tentaclon", image = "data/ui_gfx/animal_icons/tentacle_monster2.png" },
	head2 = { name = "Metastasis", image = "data/ui_gfx/animal_icons/head2.png" },
	hand2 = { name = "Meat Hand", image = "data/ui_gfx/animal_icons/hand2.png" },
	ground_flesh2 = { name = "Meat Snapper", image = "data/ui_gfx/animal_icons/ground_flesh2.png" },
	brain2 = { name = "Brain", image = "data/ui_gfx/animal_icons/brain2.png" },
	fleshclops2 = { name = "Fleshclops", image = "data/ui_gfx/animal_icons/fleshclops2.png" },
	flesh_abomination2 = { name = "Flesh Abomination", image = "data/ui_gfx/animal_icons/flesh_abomination2.png" },
	water_worm2 = { name = "Pus Parasite", image = "data/ui_gfx/animal_icons/water_worm2.png" },
	
	tower_enemies = { name = "New Enemies In Tower", image = "data/ui_gfx/animal_icons/extras/tower.png", special = true },
	coalmine_enemies = { name = "New Enemies In Mines", image = "data/ui_gfx/animal_icons/extras/coalmine.png", special = true },
	coalmine_alt_enemies = { name = "New Enemies In Collapsed Mines", image = "data/ui_gfx/animal_icons/extras/coalmine_alt.png", special = true },
	excavationsite_enemies = { name = "New Enemies In Coal Pits", image = "data/ui_gfx/animal_icons/extras/excavationsite.png", special = true },
	fungicave_enemies = { name = "New Enemies In Fungal Caverns", image = "data/ui_gfx/animal_icons/extras/fungicave.png", special = true },
	snowcave_enemies = { name = "New Enemies In Snowy Depths", image = "data/ui_gfx/animal_icons/extras/snowcave.png", special = true },
	snowcastle_enemies = { name = "New Enemies In Hiisi Base", image = "data/ui_gfx/animal_icons/extras/snowcastle.png", special = true },
	sandcave_enemies = { name = "New Enemies In Sand Cave", image = "data/ui_gfx/animal_icons/extras/sandcave.png", special = true },
	rainforest_enemies = { name = "New Enemies In Jungle", image = "data/ui_gfx/animal_icons/extras/rainforest.png", special = true },
	rainforest_dark_enemies = { name = "New Enemies In Lukki Lair", image = "data/ui_gfx/animal_icons/extras/rainforest_dark.png", special = true },
	fungiforest_enemies = { name = "New Enemies In Overgrown Caverns", image = "data/ui_gfx/animal_icons/extras/fungiforest.png", special = true },
	vault_enemies = { name = "New Enemies In Vault", image = "data/ui_gfx/animal_icons/extras/vault.png", special = true },
	vault_frozen_enemies = { name = "New Enemies In Frozen Vault", image = "data/ui_gfx/animal_icons/extras/vault_frozen.png", special = true },
	robobase_enemies = { name = "New Enemies In Power Plant", image = "data/ui_gfx/animal_icons/extras/robobase.png", special = true },
	crypt_enemies = { name = "New Enemies In Temple Of The Art", image = "data/ui_gfx/animal_icons/extras/crypt.png", special = true },
	wandcave_enemies = { name = "New Enemies In Magical Temple", image = "data/ui_gfx/animal_icons/extras/wandcave.png", special = true },
	pyramid_enemies = { name = "New Enemies In Pyramid", image = "data/ui_gfx/animal_icons/extras/pyramid.png", special = true },
	winter_enemies = { name = "New Enemies In Snowy Chasm", image = "data/ui_gfx/animal_icons/extras/winter.png", special = true },
	liquidcave_enemies = { name = "New Enemies In Abandoned Alchemy Lab", image = "data/ui_gfx/animal_icons/extras/liquidcave.png", special = true },
	wizardcave_enemies = { name = "New Enemies In Wizards' Den", image = "data/ui_gfx/animal_icons/extras/wizardcave.png", special = true },
	clouds_enemies = { name = "New Enemies In Cloudscape", image = "data/ui_gfx/animal_icons/extras/clouds.png", special = true },
	meat_enemies = { name = "New Enemies In Meat Realm", image = "data/ui_gfx/animal_icons/extras/meat.png", special = true },
	the_end_enemies = { name = "New Enemies In Hell", image = "data/ui_gfx/animal_icons/extras/the_end.png", special = true },
	the_sky_enemies = { name = "New Enemies In Sky", image = "data/ui_gfx/animal_icons/extras/the_sky.png", special = true }

}

local function MakeEnemyTable(...)
  local enemies = {...}
  local enemy_table = {}
  for i, enemy in ipairs(enemies) do
    local enemy_key = type(enemy) == "string" and enemy or enemy.key
    if not enemy_data[enemy_key] then
      error("No enemy defined by key " .. enemy_key, 2)
    end
    local out = {
      key = enemy_key,
      name = enemy_data[enemy_key].name,
      image = enemy_data[enemy_key].image,
      special = enemy_data[enemy_key].special or false
    }
    if type(enemy) == "table" then
      out.default = enemy.default
    end
    table.insert(enemy_table, out)
  end
  -- Ensure special buttons are at the beginning
  table.sort(enemy_table, function(a, b) 
	if a.special and not b.special then
	  return true
	elseif a.special and b.special then
	  return a.name < b.name
	end
	return false

  end)
  return enemy_table
end

local enemies = {
  { category = "All", enemies = {} }, -- Don't change this, will automatically be filled
  {
    category = "Mines",
    enemies = MakeEnemyTable(
	  "coalmine_enemies",
	  "larva_crawler",
	  "beehive",
      "skeleton",
      "eye_bat",
      "irtokki",
	  "mexxi",
      "hybrid",
      "conduit",
      "hazmat",
      "axeman",
      "dripper",
      -- "desulitor",
      "longleg_big",
      "stalker",
      -- "stalker_ceiling",
      "goomonster",
      "invisiman",
      "archer",
      "monkey",
      "stone_crab",
      "mutant_blob",
      -- "bloodskull",
      "toxicmage2",
      "skullmage",
	  "wizard_tiny",
      "snowman",
      "summoner",
      "slime_ghoul",
      "beanpodupine",
      "sneeker",
      "fallen_alchemist",
      "ground_terror",
      -- "worm_eel",
      "ooion",
      "menace",
      "slimeshooter_golden",
      "player_ai",
	  "player_evil",
      "gonha",
	  "mule",
      "slimeshooter_mega"
    ),
  },
  {
    category = "Collapsed Mines",
    enemies = MakeEnemyTable(
	  "coalmine_alt_enemies",
	  "larva_crawler",
      "skeleton",
      "eye_bat",
      "axeman",
      "irtokki",
	  "mexxi",
      "miner_alcohol",
      "conduit",
      "hazmat",
      "dripper",
      -- "desulitor",
      "stalker",
	  -- "stalker_ceiling",
      "goomonster",
      "invisiman",
      "archer",
      "monkey",
      -- "worm_eel",
	  "ooion",
      "menace",
      "stone_crab",
      "mutant_blob",
      "mutant2",
      -- "bloodskull",
	  "toxicmage2",
      "skullmage",
	  "wizard_tiny",
	  "snowman",
      "summoner",
      "slime_ghoul",
	  "beanpodupine",
	  "sneeker",
      "fallen_alchemist",
      "player_ai",
	  "player_evil",
      "ground_terror",
	  "mule",
      "slimeshooter_mega"
    ),
  },
  {
    category = "Coal Pits",
    enemies = MakeEnemyTable(
	  "excavationsite_enemies",
	  "beehive",
      "crawler",
      "axeman",
	  "fireworkman",
      "irtokki",
	  "mexxi",
      "miner_alcohol",
      "dripper",
      -- "desulitor",
      "fire_crawler",
      "stalker",
	  -- "stalker_ceiling",
      "goomonster",
      "invisiman",
      "conduit",
      "hazmat",
      "archer",
      "monkey",
      "mutant2",
      "enigma",
      "bouncer",
      "frog_bot",
      "stone_crab",
      "mutant_blob",
      -- "worm_eel",
      "eye_monster",
      -- "bloodskull",
      -- "giantfirebug",
      "ooion",
      -- "menace",
      "slime_turret",
      "quin",
	  -- "flesh_wall",
      "twig",
      "gonha",
      "lost_soul",
      "slime_ghoul",
      "summoner",
	  "toxicmage_acid2",
      "earthskull",
	  -- "stingray",
      "welder",
	  "yoyoer",
      "alien",
      "sneeker",
      "ground_terror",
      "knight",
      -- "flesh_monster",
      "fungus_spore",
	  "wizard_tiny",
      "player_ai",
	  "player_evil",
	  "mule",
      "slimeshooter_mega",
      "miner_boss"
    )
  },
  {
    category = "Fungal Caverns",
    enemies = MakeEnemyTable(
	  "fungicave_enemies",
      "sporeling_tiny",
	  "beehive",
      "crawler",
      "dripper",
      "stalker",
	  -- "stalker_ceiling",
      "sporeling",
      "conduit",
      "goomonster",
      -- "ghostling",
      "invisiman",
      "mutant2",
      "frog_bot",
      "stone_crab",
      "mutant_blob",
      "toxicmage_acid2",
      "slime_ghoul",
	  "beanpodupine",
      "eye_monster",
      "fungus_swamp2",
      "smoke_bot",
      "polyp_gas",
      "ooion",
      -- "menace",
      "slime_turret",
      "drone",
      "sneeker",
      "scorpio",
  	  -- "stingray",
      "nautilus",
      "spider",
      "alien",
      "shapeshifter",
      "bluemancer",
  	  -- "flesh_wall",
      "alchaos",
      -- "blob_giant",
      "polyshooter",
      "chaoticpolyshooter",
  	  "wizard_trip",
	  "wizard_tiny",
  	  "wizard_time",
      "wizard_earthquake",
      "ground_terror",
      -- "flesh_monster",
      "fungus_spore",
      "worm_fungal",
	  "mule",
      "slimeshooter_mega",
      "shiva"
    )
  },
  {
    category = "Snowy Depths",
    enemies = MakeEnemyTable(
	  "snowcave_enemies",
      -- "icicle_ceiling",
      -- "icicle",
      "icicle_ceiling",
      "axeman",
      "invisiman",
	  "mexxi",
      -- "worm_eel",
      "bouncer",
      "frog_bot",
      "radiobot",
	  "yoyoer",
      "cryogen",
      "scavenger_laser",
      "scavenger_plasma",
	  "scavenger_electrocuter2",
      "scavenger_undercover",
      "icemage2",
  	  "wizard_time",
  	  "wizard_earthquake",
      "quin",
      "gonha",
	  "snowman",
      "summoner",
      "icicle_king",
      "head_statue_physics",
      "giant_old",
      "giant_energy",
      "giant_alt",
      "kiwiki",
      "commander",
      "icemage_big2",
      "thou",
      "ooion",
	  "sneeker",
      "scavenger_trigger",
      "ground_terror",
      "electricskull",
      "hurpa",
      "tank_boss",
      "player_ai",
	  "player_evil",
	  "mountain",
	  "mountain_large",
	  "dragon_ice",
	  "stork"
    )
  },
  {
    category = "Hiisi Base",
    enemies = MakeEnemyTable(
	  "snowcastle_enemies",
      "scavenger_civilian",
      "tank_propane",
      "miner_alcohol",
      "radiobot",
      "smoke_bot",
      "scavenger_alcohol",
	  "yoyoer",
      "scavenger_laser",
      "scavenger_plasma",
      "scavenger_electrocuter2",
      "cryogen",
      "welder",
      "scavenger_trigger",
      "scavenger_undercover",
      "cyborg",
	  "drone_face2",
      "bot",
      "laserbot",
      "commander",
      "tank_boss",
      "scavenger_king"
    )
  },
  {
    category = "Sand Cave",
    enemies = MakeEnemyTable(
	  "sandcave_enemies",
	  "yoyoer",
      "scavenger_laser",
      "scavenger_plasma",
      "scavenger_trigger",
      "scavenger_electrocuter2",
      -- "bot",
      -- "laserbot",
	  "tank_fire2",
      "scavenger_compressor",
      "scavenger_oiler",
      "scavenger_turbo",
      "scavenger_gas",
      "scavenger_alcohol",
      "tardigrade",
      "sand_worm"
    )
  },
  {
    category = "Jungle",
    enemies = MakeEnemyTable(
	  "rainforest_enemies",
	  "crawler_bug",
	  "larva_crawler",
	  "scavenger_poison_immunity",
      "irtokki",
	  "beehive",
      -- "ceilingflower",
      "landflower",
	  "jungle_flower",
	  "corpse_lily",
      "goomonster",
      "ceiling_bloom",
      "scavenger_plasma",
      "earthmage",
      "spider",
      "earthskull",
	  "tank_fire2",
      "bigfly",
      "mantis",
      "eyeling",
      "fungus_swamp2",
      -- "fireflower",
      "vine_monster",
	  "chameleon",
	  "yoyoer",
      "scavenger_trigger",
      "ground_terror",
      "player_ai",
	  "player_evil",
      "ent",
      "scavenger_compressor",
      "scavenger_oiler",
      "scavenger_turbo",
      -- "wyrm",
      "scavenger_gas",
      "scavenger_robot",
      "scavenger_alcohol",
	  "scorpio",
      "flutterpede",
      "scarab",
      -- "wanderer",
	  "lukki_weird",
      "lukki_swamp2",
      "lukki_red",
      "lukki_white",
      "lukki_blue",
      "worm_fungal",
      "scavenger_king",
      "shiva",
      "plant_boss",
      "mother_nature"
    )
  },
  {
    category = "Lukki Lair",
    enemies = MakeEnemyTable(
	  "rainforest_dark_enemies",
	  "lukki_weird",
      "skullspider",
      "lukki_white",
      "lukki_blue",
      -- "wanderer",
      "lukki_ominous",
      -- "hurpa",
      -- "worm_fungal",
      "shiva",
      "medusa",
      "khulu"
    )
  },
  {
    category = "Overgrown Caverns",
    enemies = MakeEnemyTable(
	  "fungiforest_enemies",
	  "sporeling_tiny",
      "sporeling",
	  "sporeling_large",
      "polyp_gas",
  	  "fungus_spore",
      "fungus_swamp2",
  	  "wizard_trip",
      -- "blob_giant",
      "worm_fungal"
    )
  },
  {
    category = "Vault",
    enemies = MakeEnemyTable(
	  "vault_enemies",
      "scavenger_plasma",
      "irtokki",
      "drone",
      "frog_bot",
      "radiobot",
      "drone_trail",
      "cyborg",
	  -- "tank_fire2",
	  "drone_face2",
      "bot",
      "laserbot",
	    -- "stingray",
      "nautilus",
      "scavenger_trigger",
      "shapeshifter",
      "bluemancer",
      "lavashooter",
      "alchaos",
      -- "stone_physics",
      "electricskull",
      -- "blob_giant",
      "gigashooter",
      -- "hairling",
	  -- "drake_snake",
      "scavenger_compressor_robot",
      "scavenger_oiler",
      "scavenger_radiolava",
      "scavenger_turbo_robot",
      "ground_terror",
      "oruai",
      "eradicator",
      "electrobot",
      "cargobot",
      "sawbot",
      "junkbot",
      "polyshooter",
      "chaoticpolyshooter",
	    "wizard_time",
	    "wizard_earthquake",
	    "singularitor",
      -- "wyrm",
      "scavenger_gas_robot",
      "scavenger_robot",
      "scavenger_alcohol",
      "corrupt_alchemist",
      "firemage_big",
      "eldari_big",
      "robot",
      "tank_boss",
      "train",
      "player_ai",
	  -- "player_evil",
	  "manus",
	  "wizard_madness",
	  "wizard_twin",
      "shiva",
      "scavenger_king_robot",
	  "worm_robot",
	  "terminator"
    )
  },
  {
    category = "Frozen Vault",
    enemies = MakeEnemyTable(
	  "vault_frozen_enemies",
      "scavenger_plasma",
      "drone",
      "icemage2",
	  "cryogen",
      "frog_bot",
      "radiobot",
      "drone_trail",
      "bot",
      "laserbot",
  	  -- "stingray",
      "nautilus",
      "scavenger_trigger",
      "shapeshifter",
      "lavashooter",
      -- "stone_physics",
      "electricskull",
      "gigashooter",
      "icemage_big2",
      -- "hairling",
	  "singularitor",
      "scavenger_compressor_robot",
      "scavenger_oiler",
      "scavenger_radiolava",
      "scavenger_turbo_robot",
      -- "blob_giant",
      "polyshooter",
      "chaoticpolyshooter",
      "ground_terror",
	  "oruai",
	  "eradicator",
      "electrobot",
      "cargobot",
      "sawbot",
      "junkbot",
      -- "wyrm",
      "scavenger_gas_robot",
      "scavenger_robot",
      "robot",
      "tank_boss",
	  "shiva",
      "scavenger_king_robot",
      "worm_robot",
	  "terminator"
    )
  },
  {
    category = "Power Plant",
    enemies = MakeEnemyTable(
	  "robobase_enemies",
	  "eradicator",
	  "lukki_saw",
      "drone_beam",
	  "terminator"
    )
  },
  {
    category = "Temple Of The Art",
    enemies = MakeEnemyTable(
	  "crypt_enemies",
	  "spider_crawler",
      -- "book",
      "peeper",
      "irtokki",
      "long_ghost",
      -- "stone_physics",
	  "mirror_physics",
      "nautilus",
	  "zombie_giant",
      "shapeshifter",
      "bluemancer",
      "lavashooter",
      "spooky_ghost",
      "ground_terror",
      "watermonster",
      "bloodmonster",
      "acidmonster",
      "lukki_red",
      "lukki_white",
      "lukki_blue",
      "lost_soul_big",
	  -- "drake_snake",
      "hurpa",
      "gigashooter",
      -- "hairling",
      "firemage_big",
      "eldari_big",
	  "phantom_trapper",
      "potionmaster2",
      "wandmaster2",
      "corrupt_alchemist",
      "forgotten_alchemist",
      "ghuu",
      "phan",
      "nova",
      "igu",
      "polyshooter",
      "chaoticpolyshooter",
	  "wizard_time",
      "wizard_earthquake",
      "wizard_random",
	    "singularitor",
      "bloodmage_lesser",
      "bloodmage_greater",
	  "skullspider",
      "player_decoy",
	  "player_evil",
      -- "void_mask2",
      "wraith_speed",
      "wraith_void2",
      "face_worm",
	  "manus",
	  "wizard_madness",
	  "wizard_twin",
      "shiva",
	  "gold_face_physics",
      "gazer_necromancer",
      "medusa",
	  "phantom_boss",
	  "skull_abomination",
	  "xopon",
	  "manticore",
	  "bloodmage_enlightened",
	  "blood_teddy",
	  "sochaos",
	  "lempo",
      "khulu"
    )
  },
  {
    category = "Magical Temple",
    enemies = MakeEnemyTable(
	  "wandcave_enemies",
      "peeper",
      "spider_crawler",
      -- "book",
	  "shield_physics",
      "long_ghost",
	  "flopper_mother",
      "ghostling",
      -- "drake_snake",
      "sneeker",
	  "player_evil",
      "mirror_physics",
      "shapeshifter",
      "watermonster",
      "bloodmonster",
      -- "wyrm",
      "acidmonster",
      "lukki_white",
      "lukki_blue",
      "lost_soul",
      "lost_soul_big",
	  "flopper_mother_giant",
      "hurpa",
      "gigashooter",
      -- "hairling",
      "polyshooter",
      "chaoticpolyshooter",
  	  "wizard_time",
      "wizard_earthquake",
      "ground_terror",
	  "manus",
	  "wizard_madness",
	  "wizard_twin",
      "moal",
      "gazer_necromancer",
	  "manticore",
	  "xopon",
	  "gold_face_physics",
      "cerebracle"
    )
  },
  {
    category = "Pyramid",
    enemies = MakeEnemyTable(
	  "pyramid_enemies",
      "crawler_bug",
	  "larva_crawler",
      "spider_crawler",
      "peeper",
      -- "book",
      -- "cobra",
      "mummy",
	  "scorpio",
	  "flopper_mother",
      "ghostling",
      -- "drake_snake",
      "long_ghost",
	  "mirror_physics",
      "shapeshifter",
	  "shield_physics",
      -- "stone_physics",
      "nautilus",
      "bluemancer",
      "lavashooter",
      "spooky_ghost",
      "ground_terror",
      "watermonster",
      "bloodmonster",
      "acidmonster",
      "lukki_red",
      "lukki_blue",
      "lukki_white",
	  "player_evil",
	  "manticore",
      "hurpa",
      "gigashooter",
      -- "hairling",
      "phan",
      "polyshooter",
      "chaoticpolyshooter",
      -- "wyrm",
      "darkghost",
	  "scarab",
      "manus",
	  "phantom_trapper",
      "potionmaster2",
      "wandmaster2",
      "imp",
	  "moal",
	  "gold_face_physics",
	  "phantom_boss",
      "slimeshooter_mega",
	  "skull_abomination"
    )
  },
  {
    category = "Snow Chasm",
    enemies = MakeEnemyTable(
	  "winter_enemies",
      "kiwiki",
      "icicle_king",
      "icemage_big2",
      "head_statue_physics",
	  "hurpa",
	  "mountain",
	  "mountain_large",
	  "stork"
    )
  },
  {
    category = "Abandoned Alchemy Lab",
    enemies = MakeEnemyTable(
	  "liquidcave_enemies",
      "fallen_alchemist",
      "corrupt_alchemist",
      "forgotten_alchemist",
      "potionmaster2",
      "wandmaster2",
      "minabomination"
    )
  },
  {
    category = "Wizards' Den",
    enemies = MakeEnemyTable(
	  "wizardcave_enemies",
      "lightling",
	  "wizard_tiny",
      "skullmage",
      "summoner",
      "icemage2",
      "earthmage",
      "wizard_trip",
	  "wizard_time",
      "wizard_earthquake",
      "wizard_random",
      "bloodmage_lesser",
      "bloodmage_greater",
	  "wizard_madness",
	  "wizard_twin"
    )
  },
  {
    category = "Hell",
    enemies = MakeEnemyTable(
	  "the_end_enemies",
      "lukki_red",
      "firemage_big",
      "eldari_big",
      "menhir",
      "darkghost",
      "serpentor",
      "nightmare",
      "void_mask2",
      "imp",
      "draghoul",
      "creeper",
      "wraith_speed",
      "wraith_void2",
      "moal",
      "face_worm",
  	  "shiva",
      "gazer_laser",
	  "medusa",
      "gazer_necromancer",
	  "khulu",
	  "hell_overseer",
	  "platoon"
    )
  },
  {
    category = "Sky",
    enemies = MakeEnemyTable(
      -- "wyrm",
	  "the_sky_enemies",
      "darkghost",
      "imp",
      "valkyrie2",
      "draghoul",
      "creeper",
      "wraith_speed",
      "moal",
      "face_worm",
  	  "shiva",
      "gazer_laser",
	  "medusa",
      "gazer_necromancer",
	  "khulu"
    )
  },
  {
    category = "Cloudscape",
    enemies = MakeEnemyTable(
	  "clouds_enemies",
	  "copter"
    )
  },
  {
    category = "Tower",
    enemies = MakeEnemyTable(
	  "book",
	  "hell_door",
	  "jungle_worm",
	  "worm_portal",
      "tower_enemies"
    )
  },
  {
    category = "Meat Realm",
    enemies = MakeEnemyTable(
	  "meat_enemies",
	  "water_worm2",
	  "hand2",
	  "head2",
	  "brain2",
	  "bloodskull",
	  "flesh_monster",
	  "flesh_wall",
	  "menace",
	  "ground_flesh2",
	  "bloodmage_lesser",
	  "bloodmage_greater",
	  "bloodmage_enlightened",
	  "blood_teddy",
	  "tentacle_monster2",
	  "fleshclops2",
	  "flesh_abomination2",
	  "cerebracle"
    )
  },
  {
    category = "Bosses",
    enemies = MakeEnemyTable(
      { key = "bird", default = "disabled" },
      { key = "yikka", default = "disabled" },
      { key = "elephant", default = "disabled" },
      { key = "desert_mage", default = "disabled" },
      { key = "camel_robot", default = "disabled" },
      { key = "magiconstruct", default = "disabled" },
      { key = "seamonster", default = "disabled" },
      { key = "skymonster", default = "disabled" },
	  "windmill",
      { key = "giant_boss", default = "disabled" },
      { key = "lukki_dark_huge", default = "disabled" },
      { key = "golem", default = "disabled" },
      { key = "hydra", default = "disabled" },
      { key = "mwyah", default = "disabled" },
      { key = "wraith_boss", default = "disabled" },
      { key = "god_warrior", default = "disabled"},
	  { key = "cthulhu", default = "disabled"}
    )
  },
  {
    category = "Mini Bosses",
    enemies = MakeEnemyTable(
      "miner_boss",
      "mule",
      "slimeshooter_mega",
      "tank_boss",
      "scavenger_king",
      "scavenger_king_robot",
      "gazer_necromancer",
      "sochaos",
      "shiva",
      "tardigrade",
      "skull_abomination",
      "dragon_ice",
      "cerebracle",
	  "plant_boss",
	  "mother_nature",
	  "sand_worm",
	  "bloodmage_enlightened",
      "blood_teddy",
	  "terminator",
	  "medusa",
      "lempo",
  	  "khulu"
    )
  },
  {
    category = "Orb Bosses",
    enemies = MakeEnemyTable(
      { key = "bird", default = "disabled" },
      { key = "yikka", default = "disabled" },
      { key = "elephant", default = "disabled" },
      { key = "desert_mage", default = "disabled" },
      { key = "camel_robot", default = "disabled" },
      { key = "magiconstruct", default = "disabled" },
      { key = "giant_boss", default = "disabled" },
      { key = "lukki_dark_huge", default = "disabled" },
      { key = "hydra", default = "disabled" },
      { key = "mwyah", default = "disabled" }
    )
  },
  {
    category = "NG+ Orb Bosses",
    enemies = MakeEnemyTable(
      { key = "cyclops_slime", default = "disabled" },
	  { key = "boss_fungus", default = "disabled" },
      { key = "ear_boss", default = "disabled" },
      { key = "boss_eel", default = "disabled" }
    )
  },
  {
    category = "Essence Rooms",
    enemies = MakeEnemyTable(
      { key = "seamonster", default = "disabled" },
      { key = "skymonster", default = "disabled" },
      { key = "golem", default = "disabled" },
      { key = "wraith_boss", default = "disabled" },
      { key = "god_warrior", default = "disabled"},
	  { key = "cthulhu", default = "disabled"}
    )
  },
 {
    category = "Secret Bosses",
    enemies = MakeEnemyTable(
	  "windmill",
      "aquatitan",
      "desert_skull",
	  "hellion",
	  "mechahub",
	  "devourer",
	  { key = "god_warrior", default = "disabled"},
	  { key = "cthulhu", default = "disabled"}
    )
  },
  {
    category = "Lake",
    enemies = MakeEnemyTable(
      "puffer",
      "jellyfish",
      "giant_squid",
      "sea_angler2",
      "sea_angler",
      "sea_sharks",
	  "alligator_small",
      "alligator",
      "zap_eel2",
      "piranha",
      "whale",
      "devourer",
      "aquatitan"
    )
  },
  {
    category = "Holy Mountain",
    enemies = MakeEnemyTable(
	  "jungle_deity",
      "necromancer_omega"
    )
  },
  {
    category = "Special",
    enemies = MakeEnemyTable(
      "peasants",
      "huts",
      "ritualists",
      "llama",
      "camels",
      "mammoths",
      "boids",
      "chest_great_mimic",
	  "platoon",
	  "elephant_robot",
	  "drill_giant",
      { key = "lake_statue", default = "disabled" }
	  -- { key = "ants", default = "disabled" },
	  -- { key = "water_bugs", default = "disabled" },
	  -- { key = "earth_worms", default = "disabled" },
	  -- { key = "spiders", default = "disabled" }
    )
  },
}

local enemies_special = {}
local already_inserted = {}
for i, category in ipairs(enemies) do
  for j, enemy in ipairs(category.enemies) do
    if not enemy.special and not already_inserted[enemy.key] then
		table.insert(enemies[1].enemies, enemy)
		already_inserted[enemy.key] = true
	elseif ( enemy.special == true ) and not already_inserted[enemy.key] then
		table.insert(enemies_special, enemy)
		already_inserted[enemy.key] = true
    end
  end
end

dofile_once("data/scripts/lib/utilities.lua")

local categories = enemies
-- local categories = dofile_once("data/scripts/enemies_gui/enemies.lua")

local function deepcopy(orig)
  local orig_type = type(orig)
  local copy
  if orig_type == 'table' then
      copy = {}
      for orig_key, orig_value in next, orig, nil do
          copy[deepcopy(orig_key)] = deepcopy(orig_value)
      end
      setmetatable(copy, deepcopy(getmetatable(orig)))
  else -- number, string, boolean, etc
      copy = orig
  end
  return copy
end

local sorting_functions = {
  {
    name = "Alphabet Ascending",
    func = function(t)
      table.sort(t, function(a, b)
        return a.name < b.name
      end)
      return t
    end,
  },
  {
    name = "Alphabet Descending",
    func = function(t)
      table.sort(t, function(a, b)
        return a.name > b.name
      end)
      return t
    end,
  },
  -- {
    -- name = "Difficulty Easy to Hard",
    -- func = function(t)
      -- return t
    -- end,
  -- },
  -- {
    -- name = "Difficulty Hard to Easy",
    -- func = function(t)
      -- local temp = {}
      -- for i=#t, 1,-1 do
        -- -- print(i)
        -- table.insert(temp, t[i])
      -- end
      -- return temp
    -- end,
  -- },
}

local function sort_enemies_with_special_first(t, sorting_func_name)
  table.sort(t, function(a, b) 
    if a.special and not b.special then
      return true
    elseif not a.special and b.special then
      return false
    elseif sorting_func_name == "Alphabet Ascending" then
      return a.name < b.name
    elseif sorting_func_name == "Alphabet Descending" then
      return a.name > b.name
    end
  end)
  return t
end

gui = gui or GuiCreate()
open = open or false
page = page or 1
current_id = 1
selected_category_index = selected_category_index or 1
selected_page_number = selected_page_number or 1
sorting_function_index = sorting_function_index or 1
enemies = sort_enemies_with_special_first(sorting_functions[sorting_function_index].func(deepcopy(categories[selected_category_index].enemies)), sorting_functions[sorting_function_index].name)
enemies_per_page = 40
enemies_per_row = 8

function new_id()
  current_id = current_id + 1
  return current_id
end

function CustomImageButton(gui, offset_x, offset_y, text, image)
  GuiImage(gui, new_id(), -1, 0, "mods/new_enemies/files/gui/placeholder.png", 1, 1, 1, 0)
  local ret_val = GuiButton(gui, new_id(), offset_x, offset_y, " " .. text .. " ")
  local clicked, right_clicked, hovered, x, y, width, height, draw_x, draw_y, draw_width, draw_height = GuiGetPreviousWidgetInfo(gui)
  GuiOptionsAddForNextWidget(gui, GUI_OPTION.Layout_NoLayouting)
  GuiZSetForNextWidget(gui, 2)
  GuiImageNinePiece(gui, new_id(), x + 2, y, draw_width - 5, draw_height, 1, image)
  return ret_val
end

GuiStartFrame(gui)
GuiOptionsAdd(gui, GUI_OPTION.NoPositionTween)
-- Menu toggle button
GuiLayoutBeginVertical(gui, 60, 0)
if GuiButton(gui, 20, 0, "[NE]", new_id()) then
  open = not open
end
GuiLayoutEnd(gui)

GuiLayoutBeginVertical(gui, 3, 13)

if open then
  local cx, cy = GameGetCameraPos()
  GameCreateSpriteForXFrames("mods/new_enemies/files/gui/background.png", cx, cy, true, 0, 0, 2)
  GuiLayoutBeginHorizontal(gui, 0, 0)
  GuiText(gui, 3, 0, "Toggle Enemies On and Off. You need to restart the game to see effects")
  for i,category in ipairs(categories) do
    if (i-1) % 7 == 0 then
      -- End the current column and start a new one
      GuiLayoutEnd(gui)
      GuiLayoutBeginHorizontal(gui, 0, 1)
    end
    if CustomImageButton(gui, 0, 0, category.category, "mods/new_enemies/files/gui/button_9piece"..((selected_category_index == i) and "_active" or "")..".png") then
      selected_category_index = i
      selected_page_number = 1
      -- categories = dofile("data/scripts/enemies_gui/enemies.lua")
      enemies = sort_enemies_with_special_first(sorting_functions[sorting_function_index].func(deepcopy(categories[selected_category_index].enemies)), sorting_functions[sorting_function_index].name)
    end
  end
  GuiLayoutEnd(gui)

  local horizontal_gap = 0
  local offset = -horizontal_gap
  local page_count = math.ceil(#enemies / enemies_per_page)

  GuiLayoutBeginHorizontal(gui, 0, 1.5)
  if page_count > 1 then
    -- Show page numbers
    for i=1,page_count do
      if CustomImageButton(gui, 0, 0, " " .. i .. " ", "mods/new_enemies/files/gui/button_9piece"..((selected_page_number == i) and "_active" or "")..".png") then
        selected_page_number = i
      end
    end
  end
  GuiLayoutEnd(gui)

  local function get_flag(setting)
    return (setting.default == "disabled" and "nee_" or "ned_") .. setting.key
  end

  local function is_active(setting)
    local active
    local flag = get_flag(setting)
    if setting.default == "disabled" then
      active = HasFlagPersistent(flag)
    else
      active = not HasFlagPersistent(flag)
    end
    return active
  end

  local function toggle_setting(setting, new_state)
    local active = not new_state
    local flag = get_flag(setting)
    if active then
      if setting.default == "disabled" then
        RemoveFlagPersistent(flag)
      else
        AddFlagPersistent(flag)
      end
    else
      if setting.default == "disabled" then
        AddFlagPersistent(flag)
      else
        RemoveFlagPersistent(flag)
      end
    end
  end

  GuiLayoutBeginHorizontal(gui, 0, 2)
  if CustomImageButton(gui, 0, 0, "Enable all", "mods/new_enemies/files/gui/button_9piece_green.png") then
    for i, enemy in ipairs(enemies) do
      toggle_setting(enemy, true)
    end
	if #enemies_special > 0 then
		for i, enemy in ipairs(enemies_special) do
		  toggle_setting(enemy, true)
		end
	end
  end

  if CustomImageButton(gui, 0, 0, "Disable all", "mods/new_enemies/files/gui/button_9piece_red.png") then
    for i, enemy in ipairs(enemies) do
      toggle_setting(enemy, false)
    end
	if #enemies_special > 0 then
		for i, enemy in ipairs(enemies_special) do
			toggle_setting(enemy, false)
		end
	end
  end

  if CustomImageButton(gui, 0, 0, "Sort by: " .. sorting_functions[sorting_function_index].name, "mods/new_enemies/files/gui/button_9piece_blue.png") then
    sorting_function_index = (sorting_function_index % #sorting_functions) + 1
    enemies = sort_enemies_with_special_first(sorting_functions[sorting_function_index].func(deepcopy(categories[selected_category_index].enemies)),sorting_functions[sorting_function_index].name)
  end
  GuiLayoutEnd(gui)

  GuiLayoutBeginVertical(gui, 0, 2)

  local page_start = 1 + (selected_page_number-1) * enemies_per_page
  local page_end = math.min(selected_page_number * enemies_per_page, #enemies)
  local widest_word = 0
  for i=page_start, page_end do
    if i ~= page_start and (((i-1) % enemies_per_page) % enemies_per_row == 0) then
      -- End the current column and start a new one
      GuiLayoutEnd(gui)
      offset = offset + horizontal_gap + widest_word + 40
      widest_word = 0
      GuiLayoutBeginVertical(gui, 0, 2)
    end
    local enemy = enemies[i]
    local checked = is_active(enemy)
    -- Entry begin
    GuiLayoutBeginHorizontal(gui, 0, 0)
    if GuiImageButton(gui, new_id(), offset, 0, "", "mods/new_enemies/files/gui/" .. (checked and "on" or "off") .. ".png") then
      toggle_setting(enemy, not is_active(enemy))
    end
    if enemy.image then
      GuiImage(gui, new_id(), 0, 0, enemy.image, 1, 1, 1, 0)
      GuiZSetForNextWidget(gui, 2)
      GuiImage(gui, new_id(), -18, 0, "data/ui_gfx/animal_icons/extras/back.png", 1, 1, 1, 0)
    end
    if GuiButton(gui, new_id(), 0, 3, " " .. enemy.name) then
      toggle_setting(enemy, not is_active(enemy))
    end
    GuiLayoutEnd(gui)
    -- Entry end
    widest_word = math.max(widest_word, GuiGetTextDimensions(gui, enemy.name))
  end
  GuiLayoutEnd(gui)
end

GuiLayoutEnd(gui)
