dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )
local closestEntity = get_players()[1]
local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
SetRandomSeed(day + hour + second + GameGetFrameNum(), minute + second + entity_id)

if closestEntity ~= nil then
	local cx, cy = EntityGetTransform( closestEntity )
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, cx, cy)
	if ( not did_hit ) and ( EntityGetFirstComponent( closestEntity, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( closestEntity, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, closestEntity) < 40 ) and ( is_invisible(closestEntity) == false ) then
			
		shoot_at_entity(entity_id, closestEntity, 1, 0, 0, 100, "data/entities/projectiles/orb_white_fast.xml", 20, 250, Random(0,359))
		local child = EntityLoad( "data/entities/particles/plasma_explosion_particle.xml", x, y)
		EntityAddChild(entity_id, child)
	end
end