dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y, rot = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), pos_x + pos_y + entity_id )

-- pos_x = pos_x + rand(-4, 4)
-- pos_y = pos_y + rand(-4, 4)
-- local vel_x = rand(-20, 20)
-- local vel_y = rand(-20, 20)

local entities = EntityGetInRadiusWithTag( pos_x, pos_y, 5, "fungitrap_02" )

if ( #entities > 1 ) then
	return
else
	local projectile = shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/jungle_deity/vine_projectile.xml", pos_x, pos_y, 0, 0 )
	EntitySetTransform(projectile, pos_x, pos_y, Random(0, math.pi))
	colours = {
	"1",
	"2",
	"3",
	"4",
	"5"
	}

	local random_index = Random(1, #colours)
	local colour = colours[random_index]
	local sprite_path = "data/entities/projectiles/jungle_deity/vine_projectile_sprite" .. colour .. ".xml"

	local sprite_component = EntityGetFirstComponent(projectile, "SpriteComponent")

	ComponentSetValue2(sprite_component, "image_file", sprite_path )
	
	local projectile_comp_this = EntityGetFirstComponentIncludingDisabled( entity_id, "ProjectileComponent" )
	local projectile_comp = EntityGetFirstComponentIncludingDisabled( projectile, "ProjectileComponent" )
	component_write( projectile_comp,
	{
		mWhoShot = ComponentGetValue2(projectile_comp_this, "mWhoShot")
	} )
	
	-- GamePrint(ComponentGetValue2(projectile_comp_this, "mWhoShot"))
	-- GamePrint(ComponentGetValue2(projectile_comp, "mWhoShot"))
end