dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y, dir, sx, sy = EntityGetTransform(entity_id)

local wall_offset = 100

if x < ( 0 - (wall_offset + 14 ) ) then
	EntitySetTransform(entity_id, 0 - (wall_offset + 20 ), y)
	
	local phys = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
	local targphysx, targphysy = GamePosToPhysicsPos( 0 - (wall_offset + 20 ), y )
	if ( phys ~= nil ) and ( phys > 0 ) then
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys )
		for i, body_id in ipairs(physics_bodies or {}) do
			bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
			PhysicsBodyIDSetTransform( body_id, targphysx, targphysy, bangle, -bvel_x, bvel_y, -bangular_vel)
		end
	end
	-- GamePrint("yes")
end

if x > ( 0 + (wall_offset - 14 ) ) then
	EntitySetTransform(entity_id, 0 + (wall_offset - 20 ), y)
	
	local phys = EntityGetFirstComponentIncludingDisabled(entity_id, "PhysicsBodyComponent")
	local targphysx, targphysy = GamePosToPhysicsPos( 0 + (wall_offset - 20 ), y )
	if ( phys ~= nil ) and ( phys > 0 ) then
		local physics_bodies = PhysicsBodyIDGetFromEntity( entity_id, phys )
		for i, body_id in ipairs(physics_bodies or {}) do
			bx, by, bangle, bvel_x, bvel_y, bangular_vel = PhysicsBodyIDGetTransform( body_id )
			PhysicsBodyIDSetTransform( body_id, targphysx, targphysy, bangle, -bvel_x, bvel_y, -bangular_vel )
		end
	end
	-- GamePrint("yes2")
end