dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()

local x,y = EntityGetTransform( entity_id )

local components = EntityGetComponentIncludingDisabled(entity_id, "VariableStorageComponent") or {}
local length = 600

for _, comp_id in pairs(components) do
    local var_name = ComponentGetValue(comp_id, "name")
    if var_name == "length" then
        length = ComponentGetValue2(comp_id, "value_float")
    end
end

local comps = EntityGetComponentIncludingDisabled( entity_id, "LaserEmitterComponent" )
if ( comps ~= nil ) then
	for i,comp in ipairs( comps ) do
		ComponentObjectSetValue2( comp, "laser", "max_length", length )
	end
end


-- local parent_id = EntityGetParent( entity_id )

-- -- local sprite_component = EntityGetFirstComponent(parent_id, "SpriteComponent")

-- -- ComponentSetValue2(sprite_component, "rect_animation", "attack_laser")

-- --animation
-- local sprite_comps = EntityGetComponent(parent_id, "SpriteComponent") or {}
-- for i, comp in ipairs(sprite_comps) do

	-- ComponentSetValue2(comp, "rect_animation", "attack_laser")
	
-- end
