local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local root_id = EntityGetRootEntity( entity_id )

local is_strong = 0
local is_active = 0
local percentage = 0

local strongvarcomp = get_variable_storage_component( entity_id, "is_strong" )
if ( strongvarcomp ~= nil ) then
	is_strong = ComponentGetValue2(strongvarcomp, "value_int")
end

if is_strong == 0 then
	is_active = 1
	percentage = 20
elseif is_strong == 1 then
	percentage = 25
end

if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 5 == 0 then

	if is_active == 0 then
		local varcomp = get_variable_storage_component( entity_id, "is_active" )
		if ( varcomp ~= nil ) then
			is_active = ComponentGetValue2(varcomp, "value_int")
		end
	end
	
	if is_active == 1 then
		for _, player_id in pairs(EntityGetInRadiusWithTag(x, y, 2000, "player_unit") or {}) do
			local px, py = EntityGetTransform(player_id)
			
			if ( px > x - 8 ) and
			( px < x + 8 ) and
			( py < y + 273 ) and
			( py > y - 273 ) then
				local comp = EntityGetFirstComponentIncludingDisabled( player_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local hp = ComponentGetValue2( comp, "hp" )
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local percentage_cut = hp * percentage / 100
					local percentage_cut_max = max_hp * percentage / 100
					if hp > percentage_cut_max then
						EntityInflictDamage( player_id, percentage_cut , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
						if EntityGetName( player_id ) == "hitbox" then
							EntityInflictDamage( player_id, percentage_cut , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
						end
					else
						EntityInflictDamage( player_id, hp , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
						if EntityGetName( player_id ) == "hitbox" then
							EntityInflictDamage( player_id, hp , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
						end
					end
				end
			end
		end
		for _, polymorphed_player_id in pairs(EntityGetInRadiusWithTag(x, y, 2000, "polymorphed_player") or {}) do
			local px, py = EntityGetTransform(player_id)
			
			if ( px > x - 8 ) and
			( px < x + 8 ) and
			( py < y + 273 ) and
			( py > y - 273 ) then
				local comp = EntityGetFirstComponentIncludingDisabled( player_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local hp = ComponentGetValue2( comp, "hp" )
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					local percentage_cut = hp * percentage / 100
					local percentage_cut_max = max_hp * percentage / 100
					if hp > percentage_cut_max then
						EntityInflictDamage( player_id, percentage_cut , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
					else
						EntityInflictDamage( player_id, hp , "DAMAGE_HOLY", "", "NONE", 0, 0, root_id, x, y )
					end
				end
			end
		end
	end
end