dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local proj_comp = EntityGetFirstComponent( entity_id, "ProjectileComponent" )

local who_shot = ComponentGetValue2( proj_comp, "mWhoShot" )

if EntityGetIsAlive( who_shot ) == true then
	local x, y = EntityGetTransform(entity_id)
	x = x - 1000

	local vel_x = 0
	local vel_y = -1

	if ( ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") % 2 == 0 ) then

		for i=1,800 do
			x = x + 60
			local did_hit, hit_x, hit_y = RaytracePlatforms( x, y, x, y + 2000 )
			if did_hit then
				shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/sand_geyser.xml", hit_x, hit_y, vel_x, vel_y )
			end
		end
	else
		x = x - 30
		for i=1,800 do
			x = x + 60
			local did_hit, hit_x, hit_y = RaytracePlatforms( x, y, x, y + 2000 )
			if did_hit then
				shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/sand_geyser.xml", hit_x, hit_y, vel_x, vel_y )
			end
		end
		
	end

	if ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted") >= 2 then
		EntityKill(entity_id)
	end
end