dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 350 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 350 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0  and ( is_invisible(players[1]) == false ) then

	local player_x, player_y = EntityGetTransform(players[1])

	local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
	SetRandomSeed(day + hour + second + GameGetFrameNum(), minute + second + entity_id)

	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y + 5 , player_x, player_y)

	if not did_hit and ( Random( 1, 4 ) > 1 ) then
		local angle = math.rad( Random( 1, 360 ) )
		local vel_x = 0
		local vel_y = 0
		local length = Random( 400, 700 )

		vel_x = math.cos( angle ) * length
		vel_y = 0- math.sin( angle ) * length
		shoot_projectile( entity_id, "data/entities/projectiles/tentacle_khulu.xml", x, y, vel_x, vel_y )
	end

end