dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y, rot = EntityGetTransform( entity_id )

local speed = 300
-- velocity
local vel_x,vel_y = GameGetVelocityCompVelocity(entity_id)
vel_x, vel_y = vec_normalize(vel_x, vel_y)
if vel_x == nil then return end
vel_x = vel_x * speed
vel_y = vel_y * speed

local offset_x, offset_y = vec_normalize(vel_x, vel_y)
offset_x, offset_y = vec_rotate(offset_x, offset_y, math.pi*0.5) -- perpendicular to flight direction

-- launch projectiles in parallel
local x = pos_x + offset_x
local y = pos_y + offset_y

-- slow down projectiles on the side for an arrow-y shape
local vx, vy = vel_x, vel_y

local yoyo = shoot_projectile_from_projectile(entity_id, "data/entities/projectiles/yoyo.xml", x, y, vx, vy)

local parent_id = EntityGetParent(entity_id)
EntityAddChild(parent_id, yoyo)

EntityKill(entity_id)