function is_teleporting(entity)

	local entity_id = GetUpdatedEntityID()

	for i, child_id in ipairs(EntityGetAllChildren(entity) or {}) do

		local game_effect_components = EntityGetComponentIncludingDisabled(child_id, "GameEffectComponent")
		
		for i, game_effect_component in ipairs(game_effect_components or {}) do
		
			if ( ComponentGetValue2(game_effect_component, "effect") == "PROTECTION_DURING_TELEPORT" ) then 
				return true
			end
			
		end

	end
	
	return false
	
end