function RegisterSpawnFunction() end
dofile_once("data/scripts/biomes/coalmine_alt.lua")
dofile_once("data/scripts/director_helpers.lua")

for i,enemy in ipairs(g_big_enemies) do
  if enemy.entity == "data/entities/animals/biome_spawners/coalmine_alt/player_evil_spawner.xml" then
	table.remove(g_big_enemies, i)
	break
  end
end

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y )
local random_val = Random(1, 3)
local prop = "data/entities/props/physics/minecart.xml"
if random_val == 1 then
	prop = "data/entities/props/physics_box_explosive.xml"
elseif random_val == 2 then
	prop = "data/entities/props/physics_cart.xml"
end

local pw = GetParallelWorldPosition( x, y )
local flag = "ne_player_evil_coalmine_spawned" .. tostring(pw)
if not GameHasFlagRun(flag) then
	GameAddFlagRun(flag)
	EntityLoad("data/entities/animals/player_evil_green_sleep.xml", x, y )
	EntityLoad(prop, x, y )
else
	spawn(g_big_enemies, x, y)
end

EntityKill(entity_id)