local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")

if ( controls_component ~= nil ) and ( controls_component > 0 ) then

	local input = {
		ComponentGetValue(controls_component, "mButtonDownRight"), --right
		ComponentGetValue(controls_component, "mButtonDownUp"), --up
		ComponentGetValue(controls_component, "mButtonDownLeft"), --left
		ComponentGetValue(controls_component, "mButtonDownDown"), --down
	}

	local tx = 0
	local ty = 0

	if input[1] == "1" then tx = tx + 20 end
	if input[2] == "1" then ty = ty - 20 end
	if input[3] == "1" then tx = tx - 20 end
	if input[4] == "1" then ty = ty + 20 end

	local fish_component = EntityGetFirstComponentIncludingDisabled(entity_id, "AdvancedFishAIComponent")
	if (fish_component ~= nil) and (fish_component > 0) then
		-- local vx, vy = ComponentGetValue2(fish_component, "mTargetVec")
		ComponentSetValue2(fish_component, "mTargetPos", x + tx, y + ty)
		
		local cdc_id = EntityGetFirstComponentIncludingDisabled(entity_id, "CharacterDataComponent")
		local velocity_x, velocity_y = ComponentGetValue2(cdc_id, "mVelocity")
		ComponentSetValueVector2(cdc_id, "mVelocity", velocity_x + tx, velocity_y + ty)
	end
end