local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local ghost_component = EntityGetFirstComponent(entity_id, "GhostComponent")

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")

if ( controls_component ~= nil ) and ( controls_component > 0 ) then

	local input = {
		ComponentGetValue(controls_component, "mButtonDownRight"), --right
		ComponentGetValue(controls_component, "mButtonDownUp"), --up
		ComponentGetValue(controls_component, "mButtonDownLeft"), --left
		ComponentGetValue(controls_component, "mButtonDownDown"), --down
	}

	local tx = x
	local ty = y

	if input[1] == "1" then tx = tx + 20 end
	if input[2] == "1" then ty = ty - 20 end
	if input[3] == "1" then tx = tx - 20 end
	if input[4] == "1" then ty = ty + 20 end

	local target_id = EntityGetClosestWithTag(  x, y, "player_ghost_target_entity" )
	EntitySetTransform( target_id, tx, ty)
	ComponentSetValue2(ghost_component, "target_tag", "player_ghost_target_entity")
	ComponentSetValue2(ghost_component, "mTargetEntityId", target_id)
-- EntitySave( entity_id, "mods/new_enemies/test.xml" )


end