local entity_id = GetUpdatedEntityID()

local x, y, rotation = EntityGetTransform(entity_id)

local controls_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ControlsComponent")

if ( controls_component ~= nil ) and ( controls_component > 0 ) then

	local input = {
		ComponentGetValue(controls_component, "mButtonDownRight"), --right
		ComponentGetValue(controls_component, "mButtonDownUp"), --up
		ComponentGetValue(controls_component, "mButtonDownLeft"), --left
		ComponentGetValue(controls_component, "mButtonDownDown"), --down
	}

	 -- Get the rotation of the entity

	local tx = 0
	local ty = 0

	local speed = 0.3
	local turn_speed = 0.05

	-- if input[2] == "1" then -- up
		tx = tx + math.cos(rotation) * speed * 0.8
		ty = ty + math.sin(rotation) * speed * 0.8
	-- end

	-- if input[4] == "1" then -- down
		-- tx = tx - math.cos(rotation) * speed
		-- ty = ty - math.sin(rotation) * speed
	-- end

	if input[1] == "1" then -- right
		rotation = rotation + turn_speed
	end

	if input[3] == "1" then -- left
		rotation = rotation - turn_speed
	end

	local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "WormComponent")
	if (worm_component ~= nil) and (worm_component > 0) then
		local vx, vy = ComponentGetValue2(worm_component, "mTargetVec")
		ComponentSetValue2(worm_component, "mTargetVec", vx + tx, vy + ty)
	end

end

EntitySetTransform(entity_id, x, y, rotation)