function collision_trigger(colliding_entity)
	dofile_once("data/scripts/lib/utilities.lua")
	dofile_once( "data/scripts/invisibility_check.lua" )
	local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)
	
	local cx, cy = EntityGetTransform(colliding_entity)
	local crawler_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CrawlerAnimalComponent")
	local dist = get_distance(x, y, cx, cy)
	if ( dist < 7 ) and ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(colliding_entity, "GenomeDataComponent") > 0 ) and (EntityGetHerdRelation(entity_id, colliding_entity) < 40) and ( is_invisible(colliding_entity) == false ) then
		ComponentSetValue2(crawler_component, "mFrameNextDamage", 0)
	else
		ComponentSetValue2(crawler_component, "mFrameNextDamage", 9999999)
	end
	
	local enemy, enemy_x, enemy_y
	for _,id in pairs(EntityGetInRadiusWithTag(x, y, 150, "mortal")) do
		if ( entity_id ~= id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and (EntityGetHerdRelation(entity_id, id) < 40) and ( is_invisible(id) == false ) then
			local entity_x, entity_y = EntityGetTransform(id)
			if entity_x > x - 5 and entity_y < y + 300 and entity_y > y and entity_x < x + 5 then
				enemy = id
				enemy_x = entity_x
				enemy_y = entity_y
			end
		end
	end

	if not enemy then
		local crawler_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CrawlerAnimalComponent")
		ComponentSetValue2(crawler_component, "attack_from_ceiling_check_every_n_frames", 9999999999999)
		ComponentSetValue2(crawler_component, "mFrameNextAttackFromCeilingCheck", 9999999999999)
		return 
	end

	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, enemy_x, enemy_y)
			
	if not did_hit then
		local crawler_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CrawlerAnimalComponent")
		ComponentSetValue2(crawler_component, "attack_from_ceiling_check_every_n_frames", 1)
		ComponentSetValue2(crawler_component, "mFrameNextAttackFromCeilingCheck", GameGetFrameNum())
	end


end