dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local root_id = EntityGetParent( entity_id )
local x,y = EntityGetTransform( root_id )

local angle = 0
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

-- function get_direction( x1, y1, x2, y2 )
	-- local result = math.atan2( ( y2 - y1 ), ( x2 - x1 ) )
	-- return result
-- end

if ( #players > 0 ) then
	local p = players[1]
	
	local px,py = EntityGetTransform( p )
	
	angle = get_direction( x, y, px, py )
end

-- x = x + 50

-- y = y + 50

angle = math.pi + angle

EntitySetTransform( entity_id, x + math.cos( angle ) * 20, y - math.sin( angle ) * 20  )