dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal  )
	local entity_id = GetUpdatedEntityID()
	local x,y = EntityGetTransform( entity_id )
	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(child_id, "DamageModelComponent")
		
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) and ( ( EntityGetName(child_id) == "body" ) or ( EntityGetName(child_id) == "face_worm_head" ) ) then
		
			EntityInflictDamage( child_id, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_id, x, y )
			
		end

	end
	
end