local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)
local this_component = GetUpdatedComponentID()
local times = 401
if ( this_component ~= nil ) and ( this_component > 0 ) then
	times = ComponentGetValue2(this_component, "mTimesExecuted")
end

local components = EntityGetComponent( entity_id, "VariableStorageComponent" )
if ( components ~= nil ) then
	for _,comp_id in pairs(components) do 
		local var_name = ComponentGetValue( comp_id, "name" )
		if ( var_name == "prevx") then
			var_comp_prevx = comp_id
		end
		if ( var_name == "prevy") then
			var_comp_prevy = comp_id
		end
	end
end

local prev_x = ComponentGetValue2( var_comp_prevx, "value_float" )
local prev_y = ComponentGetValue2( var_comp_prevy, "value_float" )

ComponentSetValue2(var_comp_prevx, "value_float", x)
ComponentSetValue2(var_comp_prevy, "value_float", y)

if times > 5 then

	local worm_component = EntityGetFirstComponentIncludingDisabled(entity_id, "BossDragonComponent")

	if ( worm_component ~= nil ) and ( worm_component > 0 ) then

		ComponentSetValue2(worm_component, "mPhase", 1)
		ComponentSetValue2(worm_component, "mSpeed", 8)

	end

	local did_hit, hit_x, hit_y = RaytraceSurfaces(prev_x, prev_y, x, y)
	if did_hit or ( times > 400 ) then
		EntitySetTransform(entity_id, prev_x, prev_y)
		EntityAddComponent(entity_id, "LuaComponent", {
			script_source_file="data/scripts/animals/hellion_small_shorten.lua",
			execute_every_n_frame=5,
			execute_on_added=0,
		})
		EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
	end

end

function collision_trigger( colliding_entity_id )
	local entity_id = GetUpdatedEntityID()

	EntityAddComponent(entity_id, "LuaComponent", {
		script_source_file="data/scripts/animals/hellion_small_shorten.lua",
		execute_every_n_frame=5,
		execute_on_added=0,
	})
	EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
end