dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source, is_fatal)
	local entity_id = GetUpdatedEntityID()
	local x,y = EntityGetTransform( entity_id )
	
	for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
	
		if ( sprite_component ~= nil ) and ( sprite_component > 0 ) and EntityGetName(child_id) == "trunk" then
			EntityRefreshSprite( child_id, sprite_component )
		end

		local damage_model_component = EntityGetFirstComponentIncludingDisabled(child_id, "DamageModelComponent")
		
		if ( damage_model_component ~= nil ) and ( damage_model_component > 0 ) and EntityGetName(child_id) == "trunk" then
		
			EntityInflictDamage( child_id, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_id, x, y )
			
		end
		
		local sprite_component = EntityGetFirstComponentIncludingDisabled(child_id, "SpriteComponent")

	end
end