dofile_once("data/scripts/lib/utilities.lua")

function damage_received( dmg, msg, source, is_fatal)

	local entity_id = GetUpdatedEntityID()
			
	local root_id = EntityGetRootEntity( entity_id )
	if ( root_id ~= nil ) and ( root_id > 0 ) then
		local x, y = EntityGetTransform( root_id )

		if source ~= nil and source > 0 then
			local px, py = EntityGetTransform( source )
			if py > y - 512 then
			
				if ( source ~= nil ) and ( source ~= NULL_ENTITY ) and ( source ~= entity_id ) and ( source ~= root_id ) then
					EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, source, x, y )
				else
					EntityInflictDamage( root_id, dmg, "DAMAGE_PROJECTILE", "", "BLOOD_EXPLOSION", 0, 0, entity_id, x, y )
				end
				
				local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
				if ( comp ~= nil ) then
					local max_hp = ComponentGetValue2( comp, "max_hp" )
					ComponentSetValue2( comp, "hp", max_hp )
				end
		
			end
		end
	end
	
	if EntityHasTag( source, "player_unit" ) == true then
		local varcomp = EntityGetFirstComponentIncludingDisabled( entity_id, "VariableStorageComponent" )
		if ComponentGetValue2(varcomp, "value_bool") == false then
			ComponentSetValue2(varcomp, "value_bool", true)
			local components = EntityGetComponent( root_id, "VariableStorageComponent" )
			if ( components ~= nil ) then
				for _,comp_id in pairs(components) do 
					local var_name = ComponentGetValue( comp_id, "name" )
					if ( var_name == "ascending") then
						ComponentSetValue2(comp_id, "value_bool", true)
					end
				end
			end
		end
	end
end