dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal  )

    if(is_fatal == true)then

		local entity_id    = GetUpdatedEntityID()
		local x,y = EntityGetTransform( entity_id )
		for i, child_id in ipairs(EntityGetAllChildren(entity_id) or {}) do
		
			EntityRemoveFromParent(child_id)
		
			local damage_model_component = EntityGetFirstComponentIncludingDisabled(child_id, "DamageModelComponent")
			
			if damage_model_component then
			
				EntitySetComponentIsEnabled( entity_id, damage_model_component, true )
				
				ComponentSetValue2(damage_model_component, "hp", 0)
				EntityInflictDamage( child_id, 0.04, "DAMAGE_PROJECTILE", "", "NONE", 0, 0, entity_thats_responsible, x, y )
				
			end
		
		end
		
	end
	
end