dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local range = 250
local pos_x, pos_y, rotation = EntityGetTransform(entity_id)
local root_id = EntityGetRootEntity( entity_id )

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(pos_x, pos_y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
	enemy = players[1]
	enemy_x, enemy_y = EntityGetTransform( players[1] )
end

if enemy ~= 0 and enemy ~= nil then
	if times_executed == 1 then
		GameEntityPlaySound( entity_id, "mech_boss_move_laser" )
	end
	-- if ( enemy_y > pos_y - 512 ) and ( enemy_y < pos_y + 512 ) then
		rotate_value = 0
		
		rotation = rotation - math.rad(rotate_value)
		local distance_from_center = 89
		local projectile_speed = 1
		-- SetRandomSeed(GameGetFrameNum(), x + y * i)
		-- local random_angle_adjustment = math.rad(Random(-60, 60))
		local target_x = pos_x + math.cos(rotation) * distance_from_center
		local target_y = pos_y + math.sin(rotation) * distance_from_center
		
		local vel_x = math.cos(rotation) * projectile_speed
		local vel_y = math.sin(rotation) * projectile_speed
		if times_executed < 60 then
			laser = shoot_projectile(entity_id, "data/entities/projectiles/mechahub_laser_spawner_safe.xml", target_x, target_y, vel_x, vel_y)
			EntityAddChild(entity_id, laser)
		elseif times_executed < 90 then
			laser = shoot_projectile(entity_id, "data/entities/projectiles/mechahub_laser_spawner.xml", target_x, target_y, vel_x, vel_y)
			EntityAddChild(entity_id, laser)
		end
	-- end
end

