dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 200 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 200 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then

	local x, y = EntityGetTransform( entity_id )
  
	local player_x, player_y = EntityGetTransform(players[1])
	
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x, y, player_x, player_y)
		
	if not did_hit then
		
		EntityLoad( "data/entities/projectiles/white_whirl.xml", player_x , player_y )
			
	end
  
end