dofile_once("data/scripts/lib/utilities.lua")

function damage_received( damage, message, entity_thats_responsible, is_fatal, projectile_thats_responsible  )

	local entity_id    = GetUpdatedEntityID()
	local x, y = EntityGetTransform(entity_id)
	
	local comp = EntityGetFirstComponent( entity_id, "DamageModelComponent" )
	if ( comp ~= nil ) and ( comp > 0 ) then
		local physics_source = ComponentGetValue2(comp, "mPhysicsDamageEntity")
		if EntityHasTag( physics_source, "player_projectile" ) == true then

			ComponentSetValue2( comp, "invincibility_frames", 60 )
		end
	end
	
end