dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rot, sx = EntityGetTransform(entity_id)
local comp = EntityGetFirstComponentIncludingDisabled(entity_id, "VariableStorageComponent")
if ( comp == nil ) or ( comp == 0 ) then
	EntityKill(entity_id)
else
	local target = ComponentGetValue2(comp, "value_int")
	if target > 0 then
		local tx, ty = EntityGetTransform(target)
		EntitySetTransform(entity_id, tx, ty)
	end
end

-- local comp2 = EntityGetFirstComponentIncludingDisabled(entity_id, "DamageModelComponent")
-- if ( comp2 == nil ) or ( comp2 == 0 ) then
	-- ComponentSetValue2(comp2, "mPhysicsDamageThisFrame", 0)
-- end

local players_projs = EntityGetInRadiusWithTag(x, y, 512, "player_projectile")
if ( #players_projs > 0 ) then
	for _, proj_id in ipairs(players_projs) do
		
		-- local projectile_component = EntityGetFirstComponentIncludingDisabled(proj_id, "ProjectileComponent")
		-- if ( projectile_component ~= nil ) and ( projectile_component > 0 ) then
			-- ComponentSetValue2(projectile_component, "explosion_dont_damage_shooter", true)
			-- -- ComponentSetValue2(projectile_component, "mWhoShot", proj_id)
			-- -- local damage_explosion = ComponentObjectGetValue2( projectile_component, "config_explosion", "explosion" )
			-- -- if damage_explosion > 0 then
				-- -- ComponentObjectSetValue2( projectile_component, "config_explosion", "who_is_responsible", proj_id )
			-- -- end
			-- ComponentObjectSetValue2( projectile_component, "config_explosion", "dont_damage_this", entity_id )
			
			-- local damage_explosion = ComponentObjectGetValue2( projectile_component, "config_explosion", "dont_damage_this" )

			
			-- GamePrint(EntityGetName( damage_explosion ))
		-- end
		
		local comps = EntityGetAllComponents(proj_id)
		for i, comp in ipairs(comps)  do
			local component_name = ComponentGetTypeName( comp )
			if ( component_name == "ProjectileComponent" ) or
			( component_name == "LightningComponent" ) or
			( component_name == "ExplosionComponent" ) or
			( component_name == "ExplodeOnDamageComponent" ) then
				ComponentObjectSetValue2( comp, "config_explosion", "dont_damage_this", entity_id )
			end
		end
	end
end