dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local var_comp = get_variable_storage_component( entity_id, "origin" )
local origin_x = ComponentGetValue2(var_comp, "value_int")
local origin_y = ComponentGetValue2(var_comp, "value_float")
if ComponentGetValue2(var_comp, "value_int") ~= 0 then
	local distance = get_distance(x, y, origin_x, origin_y)
	local worm_ai_component = EntityGetFirstComponentIncludingDisabled( entity_id, "WormAIComponent")
	-- if distance > 2500 then
	
	local players = {}
	local player = EntityGetWithName( "DEBUG_NAME:player" )
	if ( player ~= nil ) and ( player > 0 ) then
		players = {player}
	else
		local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
		if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
			players = {polymorphed_player}
		end
	end
	
	if BiomeMapGetName( x, y ) ~= BiomeMapGetName( origin_x, origin_y ) then
		if worm_ai_component then
			ComponentSetValue2( worm_ai_component, "mRandomTarget", origin_x, origin_y )
			ComponentSetValue2( worm_ai_component, "new_random_target_check_every", 1 )
		end
	elseif ( #players > 0 ) then
		local px, py = EntityGetTransform(players[1])
		local distance_player = get_distance(x, y, px, py)
		if distance_player < 900 then
			ComponentSetValue2( worm_ai_component, "mTargetEntityId", players[1] )
			ComponentSetValue2( worm_ai_component, "mRandomTarget", px, py )
			ComponentSetValue2( worm_ai_component, "new_random_target_check_every", 1 )
		end
	end
	
	if distance < 200 then
		ComponentSetValue2( worm_ai_component, "new_random_target_check_every", 240 )
	end
	
end