dofile_once("data/scripts/lib/utilities.lua")

local range = 300

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
if ( times_executed % 2 ) == 0 then
	local animal_ai_component = EntityGetFirstComponent(entity_id, "AnimalAIComponent")
	ComponentSetValue2(animal_ai_component, "attack_ranged_max_distance", 250)
	ComponentSetValue2(animal_ai_component, "attack_ranged_frames_between", 250)
	ComponentSetValue2(animal_ai_component, "attack_ranged_entity_file", "data/entities/projectiles/physics_spear.xml")
else
	local animal_ai_component = EntityGetFirstComponent(entity_id, "AnimalAIComponent")
	ComponentSetValue2(animal_ai_component, "attack_ranged_max_distance", 25)
	ComponentSetValue2(animal_ai_component, "attack_ranged_frames_between", 100)
	ComponentSetValue2(animal_ai_component, "attack_ranged_entity_file", "data/entities/projectiles/scorpio_venom.xml")
end