dofile_once( "data/scripts/invisibility_check.lua" )
dofile_once("data/scripts/lib/utilities.lua")
	
function collision_trigger( colliding_entity_id )

	local entity_id = GetUpdatedEntityID()
	
	if ( EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") ~= nil ) and 
	( EntityGetFirstComponent(colliding_entity_id, "GenomeDataComponent") > 0 ) and 
	( EntityGetHerdRelation( entity_id, colliding_entity_id ) < 40 ) and 
	( is_invisible(colliding_entity_id) == false ) then
	
		local x, y = EntityGetTransform( entity_id )
		
		local collision_component = EntityGetFirstComponentIncludingDisabled(entity_id, "CollisionTriggerComponent")
		ComponentSetValue2(collision_component, "timer_for_destruction", 1)
		
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
	end
end