dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y, rotation = EntityGetTransform(entity_id)
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 250 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 250 then
			players = {polymorphed_player}
		end
	end
end

if #players > 0 and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( players[1], "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, players[1]) < 40 ) and ( is_invisible(players[1]) == false ) then
  
	local player_x, player_y = EntityGetTransform(players[1])
	local did_hit, hit_x, hit_y = RaytracePlatforms(x, y, player_x, player_y)
  
	if not did_hit then
		
		rotate_value = 0
		
		rotation = rotation - math.rad(rotate_value)
		local distance_from_center = 10
		local projectile_speed = 130
		-- SetRandomSeed(GameGetFrameNum(), x + y * i)
		-- local random_angle_adjustment = math.rad(Random(-60, 60))
		local target_x = x + math.cos(rotation) * distance_from_center
		local target_y = y + math.sin(rotation) * distance_from_center
		
		local vel_x = math.cos(rotation) * projectile_speed
		local vel_y = math.sin(rotation) * projectile_speed
		
		shoot_projectile(entity_id, "data/entities/projectiles/thou_laser.xml", target_x, target_y, vel_x, vel_y)
		
	end
	
end

