dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local bosses = {}

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	if EntityHasTag( child, "boss_tag" ) == true then
		table.insert(bosses, child)
	end
end

for _, boss in ipairs(bosses or {} ) do
	if #bosses > 11 then
		EntityRemoveFromParent( bosses[1] )
		GamePrint(bosses[1])
		GamePrint(bosses[0])
	end
end