dofile_once("data/scripts/lib/utilities.lua")
dofile_once("data/scripts/perks/perk.lua")

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
	-- kill self
	local entity_id    = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )
	
	GamePlaySound("mods/new_enemies/data/sound/more_sounds/my_mod_audio.bank", "snd_mod/mech_boss_death", x, y)
	
	SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

	-- do some kind of an effect? throw some particles into the air?
	EntityLoad( "data/entities/items/wand_unshuffle_custom1.xml", x - 20, y + 12 )
	EntityLoad( "data/entities/items/wand_unshuffle_custom1.xml", x, y + 12 )
	EntityLoad( "data/entities/items/wand_unshuffle_custom1.xml", x + 20, y + 12 )
	
	perk_spawn_random( x + 30, y - 20, true )
	perk_spawn_random( x, y - 20, true )
	perk_spawn_random( x - 30, y - 20, true )
	
	EntityLoad( "data/entities/items/pickup/heart_fullhp.xml",  x, y + 30 )
	
	EntityLoad( "data/entities/buildings/mystery_teleport_back_mechahub.xml", x, y - 100 )
	
	EntityLoad( "data/entities/particles/mechahub_death_explosion.xml",  x, y )
	
	local opts = { "ORBIT_NUKES", "NUKE", "NUKE_GIGA", "HITFX_CRITICAL_OIL", "LASER_EMITTER_WIDER", "LASER_EMITTER_FOUR", "THUNDER_BLAST", "ARC_ELECTRIC", "TOUCH_OIL", "VACUUM_ENTITIES", "WALL_SQUARE"}
	local count = 3
	
	for i=1,count do
		local rnd = Random( 1, #opts )
		CreateItemActionEntity( opts[rnd], x - 30 , y )
		table.remove( opts, rnd )
		x = x + 30
	end

	--EntityKill( entity_id )
end