local doom_bringer = GetUpdatedEntityID()
local x, y = EntityGetTransform(doom_bringer)
  
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

if #players > 0 then
  local player_x, player_y = EntityGetTransform(players[1])
  
  if(x > player_x + 250) then     
      x = player_x + 250
  end
  if(x < player_x - 250) then
      x = player_x - 250
  end
  if(y > player_y + 200) then
      y = player_y + 200
  end
  if(y < player_y - 200) then
      y = player_y - 200
  end
  EntitySetTransform(doom_bringer, x, y)
end