dofile_once("data/scripts/lib/utilities.lua")

function collision_trigger(colliding_entity_id)
	local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")
	if times_executed > 1200 then
		local entity_id    = GetUpdatedEntityID()
		local root_id = EntityGetRootEntity( entity_id )
		
		local components = EntityGetComponent( root_id, "VariableStorageComponent" )
		if ( components ~= nil ) then
			for _,comp_id in pairs(components) do 
				local var_name = ComponentGetValue( comp_id, "name" )
				if ( var_name == "ascending") then
					ComponentSetValue2(comp_id, "value_bool", true)
				end
			end
		end
		EntityRemoveComponent( entity_id, GetUpdatedComponentID() )
	end
end