dofile_once( "data/scripts/invisibility_check.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local sub_verlets = {}

for _, child in ipairs(EntityGetAllChildren(entity_id) or {} ) do
	if EntityGetName(child) == "verlet" then
		verlet = child
	end
	if EntityGetName(child) == "heart" then
		controller = child
		cx, cy = EntityGetTransform(child)
	end
end

if ( controller ~= nil ) and ( controller > 0 ) then
	if times_executed < 50 then
		EntitySetTransform(controller, x, y)
	end
	
	if ( verlet ~= nil ) and ( verlet > 0 ) then
		local verlet_component = EntityGetFirstComponentIncludingDisabled(verlet, "VerletPhysicsComponent")
		local positions = ComponentGetValue2(verlet_component, "positions")
		positions[3] = x
		positions[4] = y
		
		positions[19] = cx
		positions[20] = cy
		ComponentSetValue2(verlet_component, "positions", positions)
	end
end