dofile_once("data/scripts/lib/utilities.lua")

local entity_id    = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local times = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

if times > 10 then
	if times == 11 then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
	end
	-- Retrieve the previous sine value from the component or entity
	local previous_sine_value = math.sin( ( times - 1 ) * 0.04)

	local sine_value = math.sin(times * 0.04) -- Adjust the multiplier for frequency

	if previous_sine_value <= 0 and sine_value > 0 then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", true)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", false)
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		ComponentSetValue2(sprite_component, "rect_animation", "fade_in")
		ComponentSetValue2(sprite_component, "next_rect_animation", "fireball")
	elseif previous_sine_value >= 0 and sine_value < 0 then
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_world", false)
		EntitySetComponentsWithTagEnabled(entity_id, "enabled_in_hand", true)
		local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
		ComponentSetValue2(sprite_component, "rect_animation", "fade_out")
		ComponentSetValue2(sprite_component, "next_rect_animation", "invisible")
	end
end