local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

local var_comp = EntityGetFirstComponent(entity_id, "VariableStorageComponent")
local val = ComponentGetValue2(var_comp, "value_int")
if val > 0 then
	local entity_in_water, hit_x, hit_y = RaytraceSurfacesAndLiquiform( x, y, x, y )
	local entity_in_solid, hit_x2, hit_y2 = RaytracePlatforms( x, y, x, y )
	if entity_in_water and not entity_in_solid then
		ComponentSetValue2(var_comp, "value_int", val - 1)
	end
else
	EntityKill(entity_id)
end