dofile_once("data/scripts/lib/utilities.lua")

local times_executed = ComponentGetValue2(GetUpdatedComponentID(), "mTimesExecuted")

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)

if times_executed > 0 then
	local did_hit, hit_x, hit_y = RaytraceSurfaces(x + ( 10 * times_executed ), y -8, x + ( 10 * times_executed ), y + 250)
	if did_hit then
		shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/phantom_boss_wave.xml", hit_x, hit_y, 0, 0 )
	end

	local did_hit2, hit_x2, hit_y2 = RaytraceSurfaces(x - ( 10 * times_executed ), y -8, x - ( 10 * times_executed ), y + 250)
	if did_hit2 then
		shoot_projectile_from_projectile( entity_id, "data/entities/projectiles/phantom_boss_wave.xml", hit_x2, hit_y2, 0, 0 )
	end
end