dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

local players = EntityGetWithTag("player_unit")

local theEntity = GetUpdatedEntityID()

local x, y = EntityGetTransform( theEntity )

function get_distance(dx, dy, dx2, dy2)
	return math.sqrt(((dx-dx2)^2) + ((dy-dy2)^2))
end
--local x,y = EntityGetTransform( entity_id )
local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	local px, py = EntityGetTransform(player)
	local dist = get_distance(x, y, px, py)
	if dist <= 400 then
		players = {player}
	end
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		local px, py = EntityGetTransform(polymorphed_player)
		local dist = get_distance(x, y, px, py)
		if dist <= 400 then
			players = {polymorphed_player}
		end
	end
end


if #players > 0 and ( EntityGetFirstComponent( player, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent( player, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(theEntity, player) < 40 ) and ( is_invisible(player) == false ) then

	shoot_at_entity(theEntity, player, 1, 0, 0, 1, "data/entities/projectiles/orb_blue_big.xml", 20, 99999999)
	
end