dofile_once( "data/scripts/projectiles/overmind.lua" )
dofile_once("data/scripts/lib/utilities.lua")

local entity_id = GetUpdatedEntityID()

local parent_id = EntityGetParent( entity_id )
		
local x, y = EntityGetTransform( entity_id )

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(x, y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

local target = players[1]

if ( target ~= nil ) and ( target > 0 ) then
	shoot_at_entity(parent_id, target, 1, 0, 5, 200, "data/entities/projectiles/terminator_projectile.xml", 999999999999999, 9999999999999999999999)
end
