dofile_once( "data/scripts/lib/utilities.lua" )
dofile_once( "data/scripts/invisibility_check.lua" )

function collision_trigger()

	local entity_id = GetUpdatedEntityID()
	local x, y = EntityGetTransform( entity_id )

	local player = EntityGetInRadiusWithTag(x, y, 50, "player_unit")

	local player_id = player[1]

	if #player > 0 then

	local tag = "fish_attractor"		
		if not EntityHasTag(player_id, tag) then
			if ( EntityGetFirstComponent(player_id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(player_id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, player_id) < 40 ) and ( is_invisible(player_id) == false ) then

				EntityAddTag( player_id, tag )
				
				EntityAddComponent(player_id, "LuaComponent", {
					script_source_file="mods/new_enemies/files/flesh_biome/files/scripts/fish_attractor_checker.lua",
					execute_every_n_frame=20,
					execute_on_added=0,
				}) 
			end	
		end
	end
	
end