dofile_once("data/scripts/lib/utilities.lua")

local range = 200

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform(entity_id)

local players = {}
local player = EntityGetWithName( "DEBUG_NAME:player" )
if ( player ~= nil ) and ( player > 0 ) then
	players = {player}
else
	local polymorphed_player = EntityGetClosestWithTag(pos_x, pos_y, "polymorphed_player")
	if ( polymorphed_player ~= nil ) and ( polymorphed_player > 0 ) then
		players = {polymorphed_player}
	end
end

target = players[1]
if not target or target == 0 then 
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", false)
	return
end

local tx, ty = EntityGetTransform(target)
local dist = get_distance(tx, ty, pos_x, pos_y)

if dist < range then
	-- very near
	EntitySetComponentsWithTagEnabled(entity_id, "enable_when_player_seen", true)
	local this_lua = GetUpdatedComponentID()
	EntityRemoveComponent( entity_id, this_lua )
	return
end
