dofile_once("data/scripts/lib/utilities.lua")

function shot( projectile_id )
	local entity_id = GetUpdatedEntityID()
	local x, y, succ, scale_x = EntityGetTransform(entity_id)

	local angle_max = 360
	
	local _, _, day, hour, minute, second = GameGetDateAndTimeLocal()
	SetRandomSeed(day + hour + second + GameGetFrameNum(), minute + second + entity_id)
		
	for i=1,30 do
		local vel_x = 0
		local vel_y = -20
		vel_x, vel_y = vec_rotate(vel_x, vel_y, Randomf(x, y - i*4.81, -angle_max, angle_max))

		shoot_projectile( entity_id, "data/entities/projectiles/orb_pink_fleshclops2.xml", x + vel_x * 0.5, y + vel_y * 0.5, vel_x, vel_y, false )
	end
	
	GamePlaySound("data/audio/Desktop/animals.bank", "animals/giantshooter/death", x, y)
	GameScreenshake(4)
end